//+-------------------------------------------------------------------------------------+
//|                                                                     Perevorot_T.mq4 |
//|                                                                                 hoz |
//|                                                                                     |
//+-------------------------------------------------------------------------------------+
#property copyright "hoz"
#property link      ""

#include <hoz_MakeListOfInstruments@Include.mqh>
#include <hoz_Base@Include.mqh>
#include <hoz_LoggingToAnyWhere@Include.mqh>

extern string ___H1 = " ________   _________ ";
extern string ___H3 = " _______   _______ ";
extern string ___H4 = " __    ___ ";
extern double  i_Lot = 0.1,
               i_KLot = 2,
               i_SL = 0,
               i_TP = 10;
#include <hoz_TradingFunc@Include.mqh>
extern double  i_DistanceFromLastPos = 10;
extern string ___H5 = "____    ___";
extern bool    UseBU  = false;           // /  ..
extern double  i_TriggerForBU = 25,      //  ,    ..
               i_PreservedProfit = 5;    //    ..
extern string ___H6 = "____    ___";
extern bool    TSProfitOnly = true;
extern int     TStop.Buy = 70;          //     (),    , 
extern int     TStop.Sell = 10;         //     (),    , 
extern int     TrailingStep = 20;       // ""   () (  1)
extern string ___H7 = " _____   ____ ";
extern int     i_magic = 3333021;

//   
datetime    g_lastOrderOpenTime;                                 //    
double      SL,
            TP,
            priceBU,
            gda_Point[];
int         gia_SumOrdersByName[7], gia_SumOrdersByType[3],       //  
            gia_MyOrders[][3], gia_HistoryOrders[3],
            gia_Digits[], gia_MyOrd[2],
            gi_Ticket, gi_Type;

double      gd_LastPosOOP = -1;
int         gd_LastPosType = -1;

#define     SIGNAL_NO                            -1              //  
#define     SIGNAL_BUY                            0              //   
#define     SIGNAL_SELL                           1              //   

//+---

//+-------------------------------------------------------------------------------------+
//|                                                         |
//+-------------------------------------------------------------------------------------+
int init ()
{
   //----    
   fInitBase (Symbol(), i_magic, ",");
   //----       
   if (!bb_RealTrade) { i_ListOfWorkingSymbol = Symbol();}
   //----        
   fInitListOfInstrumentsMaking();
   //----   
   fInitTradingFunc();
   ArrayResize (gia_MyOrders, bi_CntOfSMB);
   ArrayResize (gda_Point, bi_CntOfSMB);
   ArrayResize (gia_Digits, bi_CntOfSMB);

   bdt_lastBarTime = 0;
   
   return (0);
}
//+-------------------------------------------------------------------------------------+
//|                                                       |
//+-------------------------------------------------------------------------------------+
int deinit ()
{

   return (0);
}
//+-------------------------------------------------------------------------------------+
//|                                              |
//+-------------------------------------------------------------------------------------+
double LotFloor (double value)
{
   return (MathFloor(MathMin(MathMax(value, bd_MINLOT), bd_MAXLOT)/bd_LOTSTEP) * bd_LOTSTEP);
}
//+-------------------------------------------------------------------------------------+
//|                                                                    |
//+-------------------------------------------------------------------------------------+
void FindOrders (int& massive[])
{
   int li_oType;
   ArrayInitialize (massive, 0);

   for (int i=OrdersTotal()-1; i>=0; i--)
   {
      Print ("   FindOrders");
      if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
      if (OrderSymbol() != Symbol()) continue;
      if (OrderMagicNumber() != i_magic) continue;
//      Print ("AfterOrderSelect");
      li_oType = OrderType();
//      Print ("li_oType = ", li_oType);
      massive[li_oType] = massive[li_oType] + 1;
      gia_SumOrdersByType[0]++;                                            //     
      
      if (li_oType < 2) {gia_SumOrdersByType[1]++;}                        //    
      else if (li_oType >= 2 && li_oType < 6) {gia_SumOrdersByType[2]++;}  //    
   }
   Print ("   FindOrders");
}
//+-------------------------------------------------------------------------------------+
//|    ( SL  TP)                                       |
//+-------------------------------------------------------------------------------------+
void fOrderModifier ()
{
    int li_ORD;
    double ld_SL, ld_TP;
//----
    if (OrderType() % 2 == 0)
    {
        ld_TP = ND (OrderOpenPrice() + i_TP * pt);
        ld_SL = ND (OrderOpenPrice() - i_SL * pt);
    }
    else
    {
        ld_TP = ND (OrderOpenPrice() - i_TP * pt);
        ld_SL = ND (OrderOpenPrice() + i_SL * pt);
    }
    
    for (li_ORD=OrdersTotal()-1; li_ORD>=0; li_ORD--)
    {
       if (!fCheck_MyOrdersBased (li_ORD, -2, MODE_TRADES)) continue;
       fOrderModify (gi_Ticket, OrderOpenPrice(), ld_SL, ld_TP, 0, CLR_NONE);
    }
}
//+-------------------------------------------------------------------------------------+
//|     (  )                          |
//+-------------------------------------------------------------------------------------+
bool isCloseByTakeLastOpenPos (int delta)
{
   datetime lastOrderCloseTime = -1,               //     
            lastOOTHist = -1;                     //       
   int j = -1;
//   Print ("isCloseByTakeLastOpenPos:   ");
   
   for (int i=OrdersHistoryTotal()-1; i>=0; i--)
   {
      if (!OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) continue;
      if (OrderMagicNumber() != i_magic) continue;
      if (OrderSymbol() != Symbol()) continue;
      if (OrderType() > 1) continue;               //      ..
//      Print ("isCloseByTakeLastOpenPos:   !");

      if (lastOrderCloseTime < OrderCloseTime())   //   ..
      {
         lastOrderCloseTime = OrderCloseTime();   // ..    
         j = i;
//         Print ("j = " + j + "   " + TimeToStr(TimeCurrent()));
      }
   }
  if (OrderSelect(j, SELECT_BY_POS, MODE_HISTORY))
   {
      if (OrderProfit() + OrderCommission() + OrderSwap() <= 0) return (false);
//      pr ("OTP() = " + OrderTakeProfit() + "; OCP() " + OrderClosePrice() + "   " + TimeToStr(TimeCurrent()));
  //    pr ("OOP() = " + OrderOpenPrice() + "; OCP() " + OrderClosePrice() + "   " + TimeToStr(TimeCurrent()));
      if (MathAbs(OrderTakeProfit() - OrderClosePrice()) > delta * pt) return (false);
      else
      {
         lastOOTHist = OrderOpenTime();
//         Comment("\n", "FUNC isCloseByTakeLastOpenPos: ",
//                 "\n", "j = ", j,
//                 "\n", "lastOOTHist = ", TimeToStr(lastOOTHist, TIME_SECONDS));
      }
   }
   else
   {
//      Print("FUNC isCloseByTakeLastOpenPos: ");
//      Print("j = ", j);
 //     Print("     ");
              
//      Comment("\n", "FUNC isCloseByTakeLastOpenPos: ",
//              "\n", "j = ", j,
//              "\n", "     ");
      return(false);
   }
  
   for(int h=OrdersTotal()-1; h>=0; h--)
   {
      if (OrderSelect(h, SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderMagicNumber() != i_magic)   continue;
         if (OrderSymbol() != Symbol())       continue;
         if (OrderType() > 1)                 continue;
         if (lastOOTHist < OrderOpenTime()) return(false);  //        
      }
      else {Print("FUNC isCloseByTakeLastOpenPos :     ");return(false);}
   }
//   Print ("isCloseByTakeLastOpenPos:    !");
   
   return (true);
}
//+-------------------------------------------------------------------------------------+
//|                                         |
//+-------------------------------------------------------------------------------------+
double GetLastOrderLot (double& lastOrderOpenPrice, int& lastOrderType)
{
   datetime lastOrderOpenTime = 0;                    //    
   double   lastOrderLot = 0;                         //    
   
   for (int i=OrdersTotal()-1; i>=0; i--)
   {
      if (!OrderSelect(i, SELECT_BY_POS)) continue;
      if (OrderMagicNumber() != i_magic) continue;
      if (OrderSymbol() != Symbol()) continue;
  
      if (lastOrderOpenTime < OrderOpenTime())
      {
          lastOrderOpenTime = OrderOpenTime();
          lastOrderOpenPrice = OrderOpenPrice();
          lastOrderType = OrderType();
          lastOrderLot = OrderLots();
      }
   }
   
   return (lastOrderLot);
}
//+-------------------------------------------------------------------------------------+
//|                                                              |
//+-------------------------------------------------------------------------------------+
double GetArrows (int arrowDir, int index)
{
   return (iCustom(NULL, 0, "indicator02", arrowDir, index));
}
//+-------------------------------------------------------------------------------------+
//|                                                            |
//+-------------------------------------------------------------------------------------+
int fSendAnyOrders (int fi_Signal, int fi_Type, bool fb_Market = true)
{
    double ld_Lot, ld_OOP;
    int li_Ticket;
    
    if (fi_Type < 2) {ld_Lot = i_Lot;}
    else {ld_Lot = LotFloor (i_KLot * i_Lot);}

    if (fb_Market == true)          //     
    {
        if (fi_Type == OP_BUY) {ld_OOP = Ask;}
        else {ld_OOP = Bid;}
        
        li_Ticket = fOrderSend (Symbol(), fi_Type, ld_Lot, ld_OOP, i_Slippage, 0, 0, "", i_magic, 0, CLR_NONE);
    }
    else
    {
        if (fi_Signal == SIGNAL_SELL)
        {
            ld_OOP = gd_LastPosOOP - i_DistanceFromLastPos * pt;
            li_Ticket = fOrderSend (Symbol(), ld_OOP, ld_Lot, ld_OOP, i_Slippage, 0, 0, "", i_magic, 0, CLR_NONE);
        }
        if (fi_Signal == SIGNAL_SELL)
        {
            ld_OOP = gd_LastPosOOP + i_DistanceFromLastPos * pt;
            li_Ticket = fOrderSend (Symbol(), ld_OOP, ld_Lot, ld_OOP, i_Slippage, 0, 0, "", i_magic, 0, CLR_NONE);
        }
    }
}
//+-------------------------------------------------------------------------------------+
//|                                                                      |
//+-------------------------------------------------------------------------------------+
bool Trade (int fi_Signal)
{
    int li_Ticket = -1;
    
    if (fi_Signal == SIGNAL_BUY)
    {
        li_Ticket = fOrderSend (Symbol(), OP_BUY, LotFloor(i_Lot), Ask, i_Slippage, 0, 0, "", i_magic, 0, CLR_NONE);

        GetLastOrderLot(gd_LastPosOOP, gd_LastPosType);
         
        fSendAnyOrders (fi_Signal, OP_SELLSTOP, false);
    }
          
    if (fi_Signal == SIGNAL_SELL)
    {
        li_Ticket = fOrderSend (Symbol(), OP_SELLSTOP, LotFloor(i_Lot), Bid, i_Slippage, 0, 0, "", i_magic, 0, CLR_NONE);
                  
        GetLastOrderLot(gd_LastPosOOP, gd_LastPosType);
          
        fSendAnyOrders (fi_Signal, OP_BUYSTOP, false);
    }

    return (true);
}
//+-------------------------------------------------------------------------------------+
//|                                                          |
//+-------------------------------------------------------------------------------------+
int GetGeneralSignal (int total)
{
   if (total > 0) return(SIGNAL_NO);
   
   if (GetArrows(2, 2) == -1)
       if (GetArrows(2, 1) > 0)
       {
          return (SIGNAL_SELL);
       }
           
   if (GetArrows(3, 2) == -1)
       if (GetArrows(3, 1) > 0)
       {
          return (SIGNAL_BUY);
       }
   
   return (SIGNAL_NO);
}
//+-------------------------------------------------------------------------------------+
//|  start                                                               |
//+-------------------------------------------------------------------------------------+
int start ()
{
   int i, fi_Signal;
//   Print ("gia_SumOrdersByName[3] = ", gia_SumOrdersByName[3]);
   FindOrders (gia_SumOrdersByName);
   Print (" FindOrders");
   //   ,    
   if (isCloseByTakeLastOpenPos(2))
   {
       fClose_AllOrdersByRange (-2, true);

       fClose_AllOrders (-1, 0);
   }
   Print ("   ");
   fOrderModifier ();
      
   if (bdt_lastBarTime == Time[0])         //      ..
       return (0);                         // ..  

   int signal = GetGeneralSignal(gia_SumOrdersByType[0]);
   
   if (signal != SIGNAL_NO)
   {
       if (!Trade(signal))
       return(0);
   }
   else
   {
      if (gia_SumOrdersByType[0] > 0 && gia_SumOrdersByType[2] == 0)       //  -    0  -  = 0, ..
      {
          double ld_NextLot = i_KLot * GetLastOrderLot(gd_LastPosOOP, gd_LastPosType);
          double ld_OOP;
          int li_Ticket = -1;
          ld_NextLot = LotFloor(ld_NextLot);
      
          if (gd_LastPosType == OP_BUY)
          {
              ld_OOP = gd_LastPosOOP - i_DistanceFromLastPos * pt;
              li_Ticket = fOrderSend (Symbol(), OP_SELLSTOP, ld_NextLot, ld_OOP, i_Slippage, 0, 0, "", i_magic, 0, CLR_NONE);
          }
          if (gd_LastPosType == OP_SELL)
          {
              ld_OOP = gd_LastPosOOP + i_DistanceFromLastPos * pt;
              li_Ticket = fOrderSend (Symbol(), OP_BUYSTOP, ld_NextLot, ld_OOP, i_Slippage, 0, 0, "", i_magic, 0, CLR_NONE);
          }
      }
   }

   bdt_lastBarTime = Time[0];               //      ..
                                            // ..  
  
   return (0);
}

/*//_______________________________________________________________________________________//
//+-------------------------------------------------------------------------------------+
//|                                                                  |
//+-------------------------------------------------------------------------------------+
void pr (string txt)
{
   string info [];
   ArrayResize(info, 20);
   string h, m, s, cm; int i;
   
   h = DoubleToStr(Hour(), 0);    if (StringLen(h) < 2) h = "0" + h;
   m = DoubleToStr(Minute(), 0);  if (StringLen(m) < 2) m = "0" + m;
   s = DoubleToStr(Seconds(), 0); if (StringLen(s) < 2) s = "0" + s;
   txt = h + ":" + m + ":" + s + " - " + txt;
   
   for (i=20-1; i>=1; i--)
   info[i] = info[i-1];
   info[0] = txt;
   
   for (i=20-1; i>=0; i--)
   if (info[i] != "")
   {
      cm = info[i];
      ObjectCreate ("txtw"+i, OBJ_LABEL, 0, 0, 0);
      ObjectSet    ("txtw"+i, OBJPROP_CORNER, 1);
      ObjectSet    ("txtw"+i, OBJPROP_XDISTANCE, 10);
      ObjectSet    ("txtw"+i, OBJPROP_YDISTANCE, 30+15*i);
      ObjectSetText("txtw"+i, cm, 10, "Times New Roman", Green);
   }
}
*/