//+---------------------------------------------------------------------------------------------------------------------------------------+
//|                                                                                                                  hoz_Base@Library.mq4 |
//|                                                                                                                                   hoz |
//|                                                                                                                                       |
//+---------------------------------------------------------------------------------------------------------------------------------------+

#property copyright "hoz"
#property link      ""
#property library

//+---------------------------------------------------------------------------------------------------------------------------------------+
//|   .                                                                                                           |
//+---------------------------------------------------------------------------------------------------------------------------------------+
// ==================================================      =================================================+
#include <hoz_Base@Include.mqh>
#include <hoz_LoggingToAnyWhere@Include.mqh>
#include <hoz_ReturningSomeInfo@Include.mqh>
#include <hoz_HandlingWithErrorS@Include.mqh>
//+=======================================================================================================================================+
//                                                                                                                    |
//+=======================================================================================================================================+
string bs_LibName = "hoz_Base@Library";
//+=======================================================================================================================================+
//===================================================        ====================================================|
//+=======================================================================================================================================+
//+---------------------------------------------------------------------------------------------------------------------------------------+
//| 0.0    .                                                                                        |
//+----------------------------------------------      . ---------------------------------------------+
//+---    . ------------------------------------------------------------------------------------------------+
//| 1.1        .                                                                     |
//| 1.2    double    string,        |
//| 1.3  ,    ,    double.                                             |
//| 1.4  ,    ,    int.                                               |
//| 1.5  ,   /    "yyyy.mm.dd[hh:mi]",    datetime (-   1970 )|
//| 1.6   double    .                                                                     |
//| 1.7    double,     string                        |
//+---       . --------------------------------------------------------------------+
//| 2.1      .                                                                          |
//| 2.2      .                                                                                |
//| 2.3     .                                                                                   |
//| 2.4    Point  .                                                                  |
//| 2.5    .                                                                                          |
//| 2.6   (   ,         ).      |
//+---   . -------------------------------------------------------------------------------------------------------------+
//| 3.1      .                                                                                      |
//| 3.2    .                                                                                                   |
//| 3.3   STRING   VALUE.                                                                                  |
//| 3.4   STRING  ,  fs_Delimiter.                                                                     |
//| 3.5   INT    STRING.                                                                                |
//| 3.6   DOUBLE    STRING.                                                                             |
//| 3.7      INT   .                                                                          |
//| 3.8     ,  fs_Delimiter.                                                                 |
//| 3.9   .                                                                                                   |
//| 3.10   .                                                                                               |
//| 3.11  0-       .                                                               |
//| 3.12     .                                                                                          |
//| 3.13     GV-.                                                                                     |
//+---------------------------------------------------------------------------------------------------------------------------------------+
//+=======================================================================================================================================+
//|                                              .                                                     |
//+=======================================================================================================================================+
void fInitBase (string fs_SymbolList,
                string fs_MagicList,
                string fs_Delimiter = ",")
{
   bs_ExpertName = StringConcatenate (WindowExpertName(), ":  ", fGet_NameTF (Period()), "_", Symbol());
   bs_SymbolList = fs_SymbolList;
   bs_MagicList = fs_MagicList;
   bs_Delimiter = fs_Delimiter;
   bb_RealTrade = (!IsTesting() && !IsOptimization());
   bb_VirtualTrade = (IsOptimization() || (IsTesting() && !IsVisualMode()));
   if (bd_SymPoint == 0.0)
       {bd_SymPoint = fGet_Point(Symbol());}
   fGet_MarketInfo (Symbol(), -1);
   bi_LotPrecision = fLotPrecision ();
   bd_MINLOT = MarketInfo(Symbol(), MODE_MINLOT);
   bd_MAXLOT = MarketInfo(Symbol(), MODE_MAXLOT);
   bd_LOTSTEP = MarketInfo(Symbol(), MODE_LOTSTEP);
   fInitializeArray_STR (bsa_Comment, "");
    //----   ""    (gsa_Comment)
   bi_IndERR = ArraySize (bsa_Comment) - 1;
   bi_Err = GetLastError();
   //----   
   fPrint (StringConcatenate ("fInitBase() => ", fErrorToString (bi_Err)), bb_PrintPermission, bb_CommentPermission);

   return;
}
//+=======================================================================================================================================+
//+                                                    .                                                   +
//+=======================================================================================================================================+
// 1.1        . ======================================================================
double ND (double v)
{
    return (NormalizeDouble (v, bi_SymDigits));
}
//=========================================================================================================================================
// 1.2    double    string,        . =
string DToS (double v)  // DSD
{
    return (DoubleToStr (v, bi_SymDigits));
}
//=========================================================================================================================================
// 1.3  ,    ,    double. ==============================================

double SToD (string v)
{
    return (StrToDouble (v));
}
//=========================================================================================================================================
// 1.4  ,    ,    int. ================================================
int SToI (string v)
{
    return (StrToInteger (v));
}
//=========================================================================================================================================
// 1.5  ,   /    "yyyy.mm.dd[hh:mi]",    datetime (-   1970 ) =
datetime SToT (string v)
{
    return (StrToTime (v));
}
//=========================================================================================================================================
// 1.6   double    . ======================================================================
double NDByMinLotPres(double v)
{
    return (NormalizeDouble (v, bi_LotPrecision));
}
//=========================================================================================================================================
// 1.7    double,     string      . ==================
string DToSByLots (double v)
{
    return (DoubleToStr (v, bi_LotPrecision));
}
//+=======================================================================================================================================+
//+                                                .                               +
//+=======================================================================================================================================+
// 2.1      . ===========================================================================
void fGet_MarketInfo (string fs_Symbol, int fi_Ticket = 0)
{
    bool lb_CondON = true;
//----
	 if (fs_Symbol == bs_Symbol) if (fi_Ticket >= 0) lb_CondON = false;
	 
	 if (lb_CondON)
    {
		  if (fi_Ticket > 0) {bs_Symbol = OrderSymbol();}
		  else {bs_Symbol = fs_Symbol;}

		  if (bs_Symbol == Symbol()) {bi_SymDigits = Digits; bd_SymPoint = Point;}
		  else {
		      bi_SymDigits = MarketInfo (fs_Symbol, MODE_DIGITS);
		      bd_SymPoint = MarketInfo (fs_Symbol, MODE_POINT);
		  }

        if (bd_SymPoint == 0.0) {bd_SymPoint = fGet_Point (fs_Symbol);}
	 }
	
	 if (fi_Ticket > 0) {fGet_OrderDetails (fi_Ticket);}
    //----     
    RefreshRates();
    bda_Price[0] = ND (fGet_TradePrice (0, bb_RealTrade, bs_Symbol));
    bda_Price[1] = ND (fGet_TradePrice (1, bb_RealTrade, bs_Symbol));
    bd_Spread = ND (bda_Price[1] - bda_Price[0]);
//----
}
//=========================================================================================================================================
// 2.2      . =================================================================================
bool fGet_OrderDetails (int fi_Ticket)
{
//----        
    int li_LastTicket = OrderTicket();
    if (li_LastTicket != fi_Ticket)
    {   
        if (!OrderSelect (fi_Ticket, SELECT_BY_TICKET))
        {/*fSet_Comment (fi_Ticket, fi_Ticket, 100, "fGet_OrderDetails()", True, GetLastError()); return (false);*/}
    }
    //bs_Symbol = OrderSymbol();
    bi_Type = OrderType();
    bd_OpenPrice = ND (OrderOpenPrice());
    bd_CurSL = ND (OrderStopLoss());
    bd_CurTP = ND (OrderTakeProfit());
    bd_Lots = OrderLots();
    //----   
    if (li_LastTicket != fi_Ticket) {if (li_LastTicket > 0) OrderSelect (li_LastTicket, SELECT_BY_TICKET);}
//----
    return (true);
}
//=========================================================================================================================================
// 2.3     . ====================================================================================
double fGet_TradePrice (int fi_Price,           // : 0 - Bid; 1 - Ask
                        bool fb_RealTrade,      //    \
                        string fs_Symbol = "")  //  
{
    double ld_Price = 0.0;
//----
    if (fs_Symbol == "")
    {
       fs_Symbol = Symbol();
    }
    //RefreshRates();
    switch (fi_Price)
    {
       case 0:
          if (fb_RealTrade)
          {
             while (ld_Price == 0.0)
             {
                if (!IsExpertEnabled() || IsStopped())
                {
                   break;
                }
                if (fs_Symbol == Symbol())
                {
                   ld_Price = Bid;
                }
                else
                {
                   ld_Price = MarketInfo (fs_Symbol, MODE_BID);
                }
                Sleep (50);
                RefreshRates();
             }
          }
          else
          {
             if (fs_Symbol == Symbol())
             {
                return (Bid);
             }
             else
             {
                return (MarketInfo (fs_Symbol, MODE_BID));
             }
          }
          break;
       case 1:
          if (fb_RealTrade)
          {
             while (ld_Price == 0.0)
             {
                if (!IsExpertEnabled() || IsStopped())
                {
                   break;
                }
                if (fs_Symbol == Symbol())
                {
                   ld_Price = Ask;
                }
                else
                {
                   ld_Price = MarketInfo (fs_Symbol, MODE_ASK);
                }
                Sleep (50);
                RefreshRates();
             }
          }
          else
          {
             if (fs_Symbol == Symbol())
             {
                return (Ask);
             }
             else
             {
                return (MarketInfo (fs_Symbol, MODE_ASK));
             }
          }
          break;
   }
//----
   return (ld_Price);
}
//=========================================================================================================================================
// 2.4    Point  . ===================================================================
double fGet_Point (string fs_Symbol = "")
{
    double ld_Point = 0.0;
//----
    if (fs_Symbol == "")
    {
       fs_Symbol = Symbol();
    }
    ld_Point = MarketInfo (fs_Symbol, MODE_POINT);
    //----   
    if (ld_Point == 0.0)
    {
       int li_Digits = MarketInfo (fs_Symbol, MODE_DIGITS);
       if (li_Digits > 0)
       {
          ld_Point = 1.0 / MathPow (10, li_Digits);
       }
    }
    else
    {
       return (ld_Point);
    }
//----
    return (ld_Point);
}
//=========================================================================================================================================
// 2.5    . ============================================================================================
int fLotPrecision ()
{
    bi_LotPrecision = 0;

    while (bd_LOTSTEP < 1)
    {
        bd_LOTSTEP *= 10;
        bi_LotPrecision++;
    }

    return (bi_LotPrecision);
}
//=========================================================================================================================================
// 2.6   (   ,         ). =======
void fGet_Pt ()
{
    if (Digits == 2 || Digits == 4)
       pt = Point;
    if (Digits == 1 || Digits == 3 || Digits == 5)
       pt = Point * 10;
    if (Digits == 6)
       pt = Point * 100;
    if (Digits == 7)
       pt = Point * 1000;
}
//+=======================================================================================================================================+
//+                                                          .                                                          +
//+=======================================================================================================================================+
// 3.1      . =======================================================================================
int fGet_INDInArrayINT (int fi_Value,       //  
                        int fia_Array[])    //  
{
    for (int li_IND = 0; li_IND < ArraySize (fia_Array); li_IND++)
    {
        if (fia_Array[li_IND] == fi_Value)
        return (li_IND);
    }
    return (-1);
}
// ------------------------------------------------------------------ //
int fGet_INDInArraySTR (string fs_Value, string fsa_Array[])
{
    for (int li_IND = 0; li_IND < ArraySize (fsa_Array); li_IND++)
    {
        if (fsa_Array[li_IND] == fs_Value)
        return (li_IND);
    }
    return (-1);
}
// 3.2    . ====================================================================================================
int fGet_NumOfPeriods (int fi_Period)
{
    static int lia_Periods[] = {1,5,15,30,60,240,1440,10080,43200};

    for (int li_Period = 0; li_Period < ArraySize (lia_Periods); li_Period++)
    {
        if (lia_Periods[li_Period] == fi_Period)
        return (li_Period);
    }
     return (-1);
}
// 3.3   STRING   VALUE. ===================================================================================
void fInitializeArray_STR (string& fsa_Array[], string fs_Value = "")
{
    for (int li_int = 0; li_int < ArraySize (fsa_Array); li_int++)
    {
        fsa_Array[li_int] = fs_Value;
    }
}
// 3.4   STRING  ,  fs_Delimiter. ========================================================================
int fGet_StrArrayFromLine (string fs_List,             //   
                           string& fsa_OUT[],          //  
                           string fs_Delimiter = ",")  //    
{
    string tmp_str = "", tmp_char = "";
//----
    ArrayResize (fsa_OUT, 0);
    
    for (int i = 0; i < StringLen (fs_List); i++)
    {
        tmp_char = StringSubstr (fs_List, i, 1);
    
        if (tmp_char == fs_Delimiter)
        {
            if (StringTrimLeft (StringTrimRight (tmp_str)) != "")
            {
                ArrayResize (fsa_OUT, ArraySize (fsa_OUT) + 1);
                fsa_OUT[ArraySize (fsa_OUT) - 1] = tmp_str;
            }
            tmp_str = "";
        }
        else
        {
            if (tmp_char != " ") tmp_str = tmp_str + tmp_char;
        }
    }
    
    if (StringTrimLeft (StringTrimRight (tmp_str)) != "")
    {
        ArrayResize (fsa_OUT, ArraySize (fsa_OUT) + 1);
        fsa_OUT[ArraySize (fsa_OUT) - 1] = tmp_str;
    }
//----
    return (ArraySize (fsa_OUT));
}
// 3.5   INT    STRING. =================================================================================
void fCreat_StrToInt (string fsa_Value[],       //   string
                      int& fia_OUT[],           //   int
                      int fi_IND,               //    
                      int fi_Factor = 1,        // 
                      string fs_NameArray = "") //   
{
    int    li_size = ArraySize (fsa_Value);
    string ls_row = "";
//----
    ArrayResize (fia_OUT, fi_IND);
    
    for (int li_int = 0; li_int < fi_IND; li_int++)
    {
        if (li_int < li_size)
        {
            fia_OUT[li_int] = StrToInteger (fsa_Value[li_int]) * fi_Factor;
        }
        else
        {
            fia_OUT[li_int] = StrToDouble (fsa_Value[li_size - 1]) * fi_Factor;
        }
        ls_row = StringConcatenate (ls_row, fs_NameArray, "[", li_int, "] = ", fia_OUT[li_int], "; ");
    }
    
    if (fs_NameArray != "") Print (ls_row);
//----
}
// 3.6   DOUBLE    STRING. ==============================================================================
void fCreat_StrToDouble (string fsa_Value[],       //   string
                         double& fda_OUT[],        //   double
                         int fi_IND,               //    
                         double fd_Factor = 1.0,   // 
                         string fs_NameArray = "") //   
{
    int    li_size = ArraySize (fsa_Value);
    string ls_row = "";
//----
    ArrayResize (fda_OUT, fi_IND);
    
    for (int li_int = 0; li_int < fi_IND; li_int++)
    {
        if (li_int < li_size)
        {
            fda_OUT[li_int] = StrToDouble (fsa_Value[li_int]) * fd_Factor;
        }
        else
            {fda_OUT[li_int] = StrToDouble (fsa_Value[li_size - 1]) * fd_Factor;
        }
        ls_row = StringConcatenate (ls_row, fs_NameArray, "[", li_int, "] = ", fda_OUT[li_int], "; ");
    }
    
    if (fs_NameArray != "") Print (ls_row);
//----
}
// 3.7      INT   . ===========================================================================
string fCreat_StrAndArray (int fi_First,              //  1-  
                           int& fia_OUT[],            //   int
                           int fi_cntIND,             //    
                           string fs_Delimiter = ",") //     
{
    string ls_row = "";
//----
    ArrayResize (fia_OUT, fi_cntIND);
    
    for (int li_int = 0; li_int < fi_cntIND; li_int++)
    {
        if (li_int == fi_cntIND - 1) fs_Delimiter = "";
        
        fia_OUT[li_int] = fi_First + li_int;
        
        ls_row = StringConcatenate (ls_row, fia_OUT[li_int], fs_Delimiter);
    }
//----
    return (ls_row);
}
// 3.8     ,  fs_Delimiter. ==================================================================
string fCreat_StrFromArray (string fsa_Array[],          //   
                            string fs_Delimiter = ",")   //     
{
    string ls_row = "";
    int    li_size = ArraySize (fsa_Array);
//----
    for (int li_int = 0; li_int < li_size; li_int++)
    {
        if (li_int == li_size - 1) fs_Delimiter = "";
        ls_row = StringConcatenate (ls_row, fsa_Array[li_int], fs_Delimiter);
    }
//----
    return (ls_row);
}
// 3.9   . ====================================================================================================
int fInit_ArrayINT (int& fia_INT[],             //  
                    string fs_List,             //    
                    int fi_Range,               //  
                    double fd_Factor = 1.0,     // 
                    string fs_NameArray = "",   //   
                    string fs_Delimiter = ",")  //    
{
//----
    //----     -     > 1 
    if (StringFind (fs_List, fs_Delimiter) == -1) return (1);
    else
    {
        string lsa_TMP[];
        int    li_cnt = fGet_StrArrayFromLine (fs_List, lsa_TMP, ",");
  
        if (fi_Range > 0)
        {
            if (li_cnt != fi_Range)
            {
                Print (fs_NameArray, ":      !!!");
                li_cnt = fi_Range;
            }
        }
        fCreat_StrToInt (lsa_TMP, fia_INT, li_cnt, fd_Factor, fs_NameArray);
    }
//----
    return (li_cnt);
}
// ------------------------------------------------------------------------------------ //
int fInit_ArrayDBL (double& fda_DBL[],          //  
                    string fs_List,             //    
                    int fi_Range,               //  
                    double fd_Factor = 1.0,     // 
                    string fs_NameArray = "",   //   
                    string fs_Delimiter = ",")  //    
{
//----
    //----     -     > 1 
    if (StringFind (fs_List, fs_Delimiter) == -1) return (1);
    else
    {
        string lsa_TMP[];
        int    li_cnt = fGet_StrArrayFromLine (fs_List, lsa_TMP, ",");
        if (fi_Range > 0)
        {
            if (li_cnt != fi_Range)
            {
                Print (fs_NameArray, ":      !!!");
                li_cnt = fi_Range;
            }
        }
        fCreat_StrToDouble (lsa_TMP, fda_DBL, li_cnt, fd_Factor, fs_NameArray);
    }
//----
    return (li_cnt);
}
// ------------------------------------------------------------------------------------ //
int fInit_ArrayBOOL (bool& fba_BOOL[],           //  
                     string fs_List,             //    
                     int fi_Range,               //  
                     double fd_Factor = 1.0,     // 
                     string fs_NameArray = "",   //   
                     string fs_Delimiter = ",")  //    
{
//----
    //----     -     > 1 
    if (StringFind (fs_List, fs_Delimiter) == -1) return (1);
    else
    {
        string lsa_TMP[];
        int    li_cnt = fGet_StrArrayFromLine (fs_List, lsa_TMP, ","), lia_TMP[];
        if (fi_Range > 0)
        {
            if (li_cnt != fi_Range)
            {
                Print (fs_NameArray, ":      !!!");
                li_cnt = fi_Range;
            }
        }
        fCreat_StrToInt (lsa_TMP, lia_TMP, li_cnt, fd_Factor, fs_NameArray);
    }
    ArrayCopy (fba_BOOL, lia_TMP);
//----
    return (li_cnt);
}
// 3.10   . ================================================================================================
double fChoiceSource (string fs_Symbol,          // Symbol
                      int fi_Bar,                // Bar
                      datetime fdt_Time,         // Time
                      int fi_TF,                 // Period
                      double fda_Array[][],      //    
                      int fi_NSource,            //   1-  
                      bool fb_IsBufffer = true)  //  "" 
{
//----
    if (fb_IsBufffer)
    {
        //----     
        switch (fi_NSource)
        {
            case 0: return (iOpen (fs_Symbol, fi_TF, fi_Bar));
            case 1: return (iHigh (fs_Symbol, fi_TF, fi_Bar));
            case 2: return (iLow (fs_Symbol, fi_TF, fi_Bar));
            case 3: return (iClose (fs_Symbol, fi_TF, fi_Bar));
        }
    }
    else
    {
        //----    ( )
        if (fda_Array[fi_Bar][6] == fdt_Time) {return (fda_Array[fi_Bar][fi_NSource]);}
        else
        {
            for (int li_IND = 0; li_IND < ArrayRange (fda_Array, 0); li_IND++)
            {
                if (fdt_Time >= fda_Array[li_IND][6])
                {return (fda_Array[li_IND][fi_NSource]);}
            }
        }
    }
//----
    return (0.0);
}
// 3.11  0-       . ================================================================
void fShiftIndex (double& ar_MAS[],              //  
                  bool fb_Conditions = false)    //     
{
    int li_size = ArraySize (ar_MAS);
    double lda_TMP[];
//----
    //----    
    ArrayResize (lda_TMP, li_size);
    //----     
    ArrayCopy (lda_TMP, ar_MAS);
    //----  ,    
    if (fb_Conditions) ArrayResize (ar_MAS, li_size + 1);
    //----          1
    ArrayCopy (ar_MAS, lda_TMP, 1);
    //----     
    ar_MAS[0] = 0.0;
//----
}
// 3.12     . ============================================================================================
void fSort_InDecreasingSequance (int& fia_INDEX[],     //  
                                 double fda_Value[])   //  
{
    int li_IND, li_int, li_tmp, li_size = ArraySize (fda_Value);
//----
    for (li_IND = 0; li_IND < li_size; li_IND++)
    {
        fia_INDEX[li_IND] = li_IND;
    }
   
    for (li_IND = 0; li_IND < li_size; li_IND++)
    {
		  for (li_int = li_IND + 1; li_int < li_size; li_int++)
		  {
			   if (fda_Value[fia_INDEX[li_IND]] < fda_Value[fia_INDEX[li_int]])
			   {
				    li_tmp = fia_INDEX[li_int]; 
				    fia_INDEX[li_int] = fia_INDEX[li_IND]; 
				    fia_INDEX[li_IND] = li_tmp;
			   }
		  }
	 }
//----
    return;
}
// 3.13     GV-. ======================================================================================
void fCreat_ArrayGV (string& fsa_Base[],  //  
                     string fsa_Add[])    //  
{
    int li_int, li_sizeB = ArraySize (fsa_Base), li_sizeA = ArraySize (fsa_Add);
    bool lb_duble;
//----
    for (int li_IND = 0; li_IND < li_sizeA; li_IND++)
    {
        lb_duble = false;
        //----    
        for (li_int = 0; li_int < li_sizeB; li_int++)
        {
            if (fsa_Add[li_IND] == fsa_Base[li_int])
            {lb_duble = true; break;}
        }
        //----   -  
        if (lb_duble) continue;
        //----  
        li_sizeB++;
        //----   
        ArrayResize (fsa_Base, li_sizeB);
        //----      
        fsa_Base[li_sizeB - 1] = fsa_Add[li_IND];
    }
//----
}