//+---------------------------------------------------------------------------------------------------------------------------------------+
//|                                                                                                     hoz_LoggingToAnyWhere@Library.mq4 |
//|                                                                                                                                   hoz |
//|                                                                                                                                       |
//+---------------------------------------------------------------------------------------------------------------------------------------+

#property copyright "hoz"
#property link      ""
#property library

//+---------------------------------------------------------------------------------------------------------------------------------------+
//|         .                                                                |
//+---------------------------------------------------------------------------------------------------------------------------------------+

//+---------------------------------------------------------------------------------------------------------------------------------------+
//                                                                                                                    |
//+---------------------------------------------------------------------------------------------------------------------------------------+
string bs_LibName = "hoz_LoggingToAnyWhere@Library";
//+=======================================================================================================================================+
//===================================================        ====================================================|
//+=======================================================================================================================================+
//| 1.1  Log-.                                                                                                                   |
//| 1.2     ()   .                                                                                  |
//+---------------------------------------------------------------------------------------------------------------------------------------+
//----
//=========================================================================================================================================
// 1.1  Log-. ====================================================================================================================
void fWrite_Log (string fs_Txt,                       // ,     Log-
                 bool fb_PrintPermission = true,      //   
                 bool fb_CommentPermission = true)    //     
{

    static datetime ldt_NewDayOpen = 0;
    static string ls_FileName = "";
    datetime ldt_CurrDayOpen = iTime (Symbol(), NULL, PERIOD_D1);
    //----        
    if (ldt_NewDayOpen != ldt_CurrDayOpen)
    {
        ls_FileName = StringConcatenate (WindowExpertName(), "_", Symbol(), "_", Period(), "-", Month(), "-", Day(), ".log");
        ldt_NewDayOpen = ldt_CurrDayOpen;
    }
    int handle = FileOpen (ls_FileName, FILE_READ|FILE_WRITE|FILE_CSV, "/t");

    FileSeek (handle, 0, SEEK_END);      
    FileWrite (handle, StringConcatenate (TimeToStr (TimeCurrent(), TIME_DATE|TIME_SECONDS), ": ", fs_Txt));
    FileClose (handle);
   
   fPrint (fs_Txt, fb_PrintPermission, fb_CommentPermission);
}
//=========================================================================================================================================
// 1.2     ()   . ===================================================================================
void fPrint (string fs_Text,                      //   
             bool fb_PrintPermission = true,      //   
             bool fb_CommentPermission = true)    //     
{
    if (StringLen (fs_Text) > 0)
    {
        if (bs_LibName != "") fs_Text = StringConcatenate (bs_LibName, " => ", fs_Text);

        if (fb_PrintPermission)
            Print (fs_Text);

        if (fb_CommentPermission)
            Comment (fs_Text);
    }
    //----  
    //fs_Text = "";
//---- 
    return;
}