//+---------------------------------------------------------------------------------------------------------------------------------------+
//|                                                                                                 hoz_MakeListOfInstruments@Library.mq4 |
//|                                                                                                                                   hoz |
//|                                                                                                                                       |
//+---------------------------------------------------------------------------------------------------------------------------------------+

#property copyright "hoz"
#property link      ""
#property library

//+=======================================================================================================================================+
//|                                                                                          |
//+=======================================================================================================================================+
// ==================================================      =================================================+
#include <hoz_Base@Include.mqh>
#include <hoz_MakeListOfInstruments@Include.mqh>
#include <hoz_LoggingToAnyWhere@Include.mqh>
#include <hoz_HandlingWithErrorS@Include.mqh>
//+=======================================================================================================================================+
//===================================================        ====================================================|
//+=======================================================================================================================================+
//+---------------------------------------------------------------------------------------------------------------------------------------+
//| 0.0  .                                                                                                             |
//+---   . ------------------------------------------------------------------------------------------------------------------+
//| 1.1         .                                                                        |
//| 1.2     .                                                                                     |
//| 1.3       .                                                                                      |
//| 1.4      .                                                                                 |
//+---------------------------------------------------------------------------------------------------------------------------------------+

//+=======================================================================================================================================+
//|                                                       .                                                            |
//+=======================================================================================================================================+
void fInitListOfInstrumentsMaking()
{
    //----         
    bi_CntOfSMB = fCreat_WorkingSymbolsArray (bsa_WorkingSMB, i_ListOfWorkingSymbol, i_BASECurrencyList, i_BADCurrencyList, i_MAXSpread);
    //----     
    bs_SymbolList = fCreat_StrFromArray (bsa_WorkingSMB, ",");
    Print (bi_CntOfSMB, " : ", bs_SymbolList);
    //----      
    if (!fCheck_ExternParameters())
    {
        Alert ("   hoz_MakeListOfInstruments !!!");
        return;
    }
    //----   
	 fPrint (StringConcatenate ("fCheck_ExternParameters => ", fErrorToString (bi_Err)), bb_PrintPermission, bb_CommentPermission);
//----
}
// 1.1         . =========================================================================
int fCreat_WorkingSymbolsArray (string& fsa_WorkingSMB[],            //    
                                string  fs_ListOfWorkingSymbols,     //   
                                string  fs_BaseCurrency,             //   
                                string  fs_BadCurrency,              // ""   ( )
                                int     fi_MAXspread = 0,            //  
                                string  fs_Delimiter = ",")          //    
{
    int bi_Err = -1,
        li_cntOfSMB = 0;
    //----    
    if (fs_ListOfWorkingSymbols == "")
    {
        string lsa_AllSymbols[], lsa_ProperCUR[], lsa_BadCUR[];
        int    li_Cnt = 0, li_CUR, li_BAD, li_CntProperCUR, li_CntBadCUR;
        bool   lb_Bad;
        //----      
        li_CntProperCUR = fGet_StrArrayFromLine (fs_BaseCurrency, lsa_ProperCUR, ",");
        //----    ""  
        li_CntBadCUR = fGet_StrArrayFromLine (fs_BadCurrency, lsa_BadCUR, ",");
        //----     " "
        li_Cnt = fListOfSymbols (lsa_AllSymbols, True);
        
        ArrayResize (fsa_WorkingSMB, li_Cnt);
        
        if (li_CntProperCUR == 0)
        {
            li_CntProperCUR = 1;
            ArrayResize (lsa_ProperCUR, 1);
        }
        fInitializeArray_STR (fsa_WorkingSMB, "");
        
        //----    ,    "" 
        for (int li_SMB = 0; li_SMB < li_Cnt; li_SMB++)
        {
            for (li_CUR = 0; li_CUR < li_CntProperCUR; li_CUR++)
            {
                if (StringFind (lsa_AllSymbols[li_SMB], lsa_ProperCUR[li_CUR]) >= 0 || fs_BaseCurrency == "")
                {
                    if (li_CntBadCUR > 0)
                    {
                        //----    "" 
                        lb_Bad = false;
        
                        for (li_BAD = 0; li_BAD < li_CntBadCUR; li_BAD++)
                        {
                            if (StringFind (lsa_AllSymbols[li_SMB], lsa_BadCUR[li_BAD]) >= 0)
                            {
                                lb_Bad = true; break;
                            }
                        }
                        if (lb_Bad) break;
                    }
                    //----    "" 
                    if (fi_MAXspread > 0)
                    {
                        if (MarketInfo (lsa_AllSymbols[li_SMB], MODE_SPREAD) > fi_MAXspread)
                        break;
                    }
                    fsa_WorkingSMB[li_cntOfSMB] = lsa_AllSymbols[li_SMB];
                    li_cntOfSMB++;
                    break;
                }
            }
        }
        ArrayResize (fsa_WorkingSMB, li_cntOfSMB);
    }
    else
    {
        li_cntOfSMB = fGet_StrArrayFromLine (fs_ListOfWorkingSymbols, fsa_WorkingSMB, ",");
        //----       
        li_cntOfSMB = fCheck_PresenceSMBInMarket (fsa_WorkingSMB);
    }
    //----   
    fPrint (StringConcatenate ("fCreat_ArraySymbols => ", fErrorToString (bi_Err)), bb_PrintPermission, bb_CommentPermission);
//----
    return (li_cntOfSMB);
}
// 1.2     . ======================================================================================
int fListOfSymbols (string& fs_Symbols[],       //     
                   bool fb_Looking)             // True -  ` `
{
    string ls_NameOfFile, ls_Txt;
    int li_Offset, li_CountOfSymbols;
    static bool lb_FirstRun = true;
//----
    if (fb_Looking)
    {
        ls_NameOfFile = "symbols.sel";
    }
    else
    {
        ls_NameOfFile = "symbols.raw";
    }
    //----     
    int hFile = FileOpenHistory (ls_NameOfFile, FILE_BIN|FILE_READ);
    
    if (hFile < 0)
    {
        Print ("   ", ls_NameOfFile, ": ", GetLastError());
        return (-1);
    }
    //----   ,   
    if (fb_Looking)
    {
        li_CountOfSymbols = (FileSize (hFile) - 4) / 128;
        li_Offset = 116;
    }
    else
    {
        li_CountOfSymbols = FileSize (hFile) / 1936;
        li_Offset = 1924;
     }
    ArrayResize (fs_Symbols, li_CountOfSymbols);
    //----     4 ,    MQL
    if (fb_Looking)
    {
        if (!FileSeek (hFile, 4, SEEK_SET))
        {
            Print ("C     4   symbols.sel ", ls_NameOfFile, "  : ", GetLastError());
        }
    }
    //----         symbols.sel
    for (int i = 0; i < li_CountOfSymbols; i++)
    {
        fs_Symbols[i] = FileReadString (hFile, 12);
        
        if (!FileSeek (hFile, li_Offset, SEEK_CUR))
        {
            Print ("    li_Offset   symbols.sel ", ls_NameOfFile, "  : ", GetLastError());
        }
    }
    FileClose (hFile);
    //----        
    if (lb_FirstRun)
    {
        if (fb_Looking)
        {
            ls_Txt = "  ` ` ";
        }
        else
        {
            ls_Txt = ",   ";
        }
        Print ("   ", ls_Txt, AccountCompany(), "  ", li_CountOfSymbols);
        lb_FirstRun = false;
    }
    //----    
    return (li_CountOfSymbols);
}
// 1.3       . =================================================================================
int fCheck_PresenceSMBInMarket (string& fsa_WorkingSMB[])
{
    if (!bb_RealTrade) return (1);
//----
    string lsa_Copy[];        //    
    int li_Cnt = 0, li_Size = ArraySize (fsa_WorkingSMB);
//----
    ArrayResize (lsa_Copy, li_Size);
    ArrayCopy (lsa_Copy, fsa_WorkingSMB);
 
    for (int li_SMB = 0; li_SMB < li_Size; li_SMB++)
    {
        if (MarketInfo (lsa_Copy[li_SMB], MODE_BID) == 0.0)
        {
            Print (AccountCompany(), "   ", lsa_Copy[li_SMB]); continue;
        }
        fsa_WorkingSMB[li_Cnt] = lsa_Copy[li_SMB];
        li_Cnt++;
    }
    if (li_Size != li_Cnt) ArrayResize (fsa_WorkingSMB, li_Cnt);
//----
    return (li_Cnt);
}
// 1.4      . ==================================================================================
bool fCheck_ExternParameters()
{
    bi_Err = -1;
//----
    if (i_MAXSpread < 0)
    {
        Print (" MAX_Spread >= 0 !!!");
        return (false);
    }
    //----   
	 fPrint (StringConcatenate ("fCheck_ExternParameters => ", fErrorToString (bi_Err)), bb_PrintPermission, bb_CommentPermission);
//----
     return (true);
}