//+---------------------------------------------------------------------------------------------------------------------------------------+
//|                                                                                                           hoz_TradingFunc@library.mq4 |
//|                                                                                                                                   hoz |
//|                                                                                                                                       |
//+---------------------------------------------------------------------------------------------------------------------------------------+
#property copyright "hoz"
#property link      ""
#property library

//+=======================================================================================================================================+
//|                                                                                                              |
//+=======================================================================================================================================+
// ===========================================================    ================================================================
#define WM_COMMAND  0x0111
// ==================================================      =================================================+
#include <hoz_Base@Include.mqh>
#include <hoz_TradingFunc@Include.mqh>
#include <hoz_LoggingToAnyWhere@Include.mqh>
#include <hoz_HandlingWithErrorS@Include.mqh>
#include <hoz_ReturningSomeInfo@Include.mqh>

#import "user32.dll"
    int GetAncestor (int hWnd, int gaFlags);
    int PostMessageA (int hWnd, int Msg, int wParam, string lParam);
#import

//+=======================================================================================================================================+
//                                                                                                                    |
//+=======================================================================================================================================+
string bs_LibName = "hoz_TradingFunc@library";
// =====================================================    =====================================================
color bca_Send[2],                          //      
      bca_Close[2],                         //      \
      bca_Modify[2];                        //      
      
//+=======================================================================================================================================+
//===================================================        ====================================================|
//+=======================================================================================================================================+
//+---------------------------------------------------------------------------------------------------------------------------------------+
//| 0.0    .                                                                                        |
//+----------------------------------------------      . ---------------------------------------------+
//| 1.1   .                                                                                                           |
//| 1.2     ( TP  SL)                                                                         |
//| 1.3     .                                                                                      |
//| 1.4      .                                                                            |
//| 1.5     .                                                                                      |
//| 1.6     .                                                                                            |
//| 1.7         .                                                            |
//| 1.8       .                                                                        |
//+--------------------------           . ----------------------------+
//| 2.1   StopLevel TP  SL.( ,    TP  SL)                                            |
//| 2.2       .                                                                         |
//| 2.3   STOPLEVEL  FREEZLEVEL.                                                                                     |
//+----------------------------------------------    . -------------------------------------------------------+
//| 3.1     .                                                                                                         |
//| 3.2     .                                                                                             |
//| 3.3  ""    .                                                                               |
//| 3.4  "" .                                                                                                           |
//| 3.5   ,   .                                                                          |
//+---------------------------------------------------------------------------------------------------------------------------------------+

//+=======================================================================================================================================+
//|                                                       .                                                            |
//+=======================================================================================================================================+
void fInitTradingFunc()
{
//----    
    bca_Send[0] = i_ColSend_BUY;
    bca_Send[1] = i_olSend_SELL;
    bca_Close[0] = i_olClose_BUY;
    bca_Close[1] = i_olClose_SELL;
    bca_Modify[0] = i_olModify_BUY;
    bca_Modify[1] = i_olModify_SELL;
    if (i_NumberOfTry == 0) i_NumberOfTry = 200;
    //----   
   fPrint (StringConcatenate ("fInitTradingFunc() => ", fErrorToString (bi_Err)), bb_PrintPermission, bb_CommentPermission);
}
//+=======================================================================================================================================+
//+                                                    .                                              +
//+=======================================================================================================================================+
// 1.1   . ============================================================================================================
int fOrderSend (string fs_Symbol,             // OrderSymbol()
                int fi_Type,                  // OrderType()
                double fd_Lot,                // OrderLots()
                double fd_Price,              // OrderOpenPrice()
                int fi_Slip,                  // Slippage
                double fd_SL,                 // OrderStopLoss()
                double fd_TP,                 // OrderTakeProfit()
                string fs_Comm = "",          // OrderComment()
                int fi_Magic = 0,             // OrderMagicNumber()
                datetime fdt_Expiration = 0,  //    
                color fc_Arrow = CLR_NONE)    //     
{
    int    li_Cnt = 0,
           li_Ticket = -1,
           cmd;
    bool   lb_InvalidSTOP = false,
           lb_FixInvalidPrice = false;
    //----     
    fGet_MarketInfo (fs_Symbol, -1);
    //----    FREEZELEVEL  STOPLEVEL
    if (!fCheck_LevelsBLOCK (2, fs_Symbol, fi_Type, fd_Price, fd_SL, fd_TP, lb_FixInvalidPrice))
    {
       if (StringLen (bs_ErrorTL) > 0)
       {
          fWrite_Log (bs_ErrorTL, bb_PrintPermission, bb_CommentPermission);
       }
       return (-1);
    }
    bi_Err = -1;
    fd_Price = ND (fd_Price);
    
    if (fc_Arrow == CLR_NONE)
       fc_Arrow = bca_Send[fi_Type % 2];
    
    if (!bb_MMM)
        fd_Lot = MathMin (fd_Lot, bd_MAXLOT);

    double ld_Lots = MathMin (fd_Lot, bd_MAXLOT);

    if (!bb_RealTrade)
    {
        while (fd_Lot > 0.0)     //----        ( )
        {
            li_Ticket = OrderSend (fs_Symbol, fi_Type, ld_Lots, fd_Price, fi_Slip, 0, 0, fs_Comm, fi_Magic, fdt_Expiration, fc_Arrow);
     
            if (li_Ticket > 0)
            {  
                if (fd_SL != 0.0 || fd_TP != 0.0)
                {
                    if (OrderSelect (li_Ticket, SELECT_BY_TICKET))
                    {
                        fOrderModify (li_Ticket, OrderOpenPrice(), fd_SL, fd_TP, fdt_Expiration, fc_Arrow);
                    }
                }
            }
            else fWrite_Log (StringConcatenate ("fOrderSend(): ", fErrorToString (GetLastError())), bb_PrintPermission, bb_CommentPermission);
            fd_Lot -= bd_MAXLOT;
            if (fd_Lot <= 0.0)
               return (li_Ticket);
            ld_Lots = MathMin (bd_MAXLOT, fd_Lot);
        }
    }
    else
    {
        if (fi_Type % 2 == OP_BUY)
        {
           cmd = 1;
        }
        else
        {
           cmd = 0;
        }
        while (fd_Lot > 0.0)     //----        ( )
        {
            while (IsTradeAllowed() == true)
            {
                if (!IsExpertEnabled() || IsStopped() || li_Cnt > 200)
                {
                    fWrite_Log (StringConcatenate ("Error: Trying to send order ", fGet_NameOP (fi_Type), " | Price: ", DToS (fd_Price), " NOT IsTradeContextBusy"), bb_PrintPermission, bb_CommentPermission);
                    if (!IsExpertEnabled())
                    {
                       fWrite_Log ("Permit ExpertEnabled !!!", bb_PrintPermission, bb_CommentPermission);
                    }
                    return (-1);
                }
                li_Ticket = OrderSend (fs_Symbol, fi_Type, ld_Lots, fd_Price, fi_Slip, 0, 0, fs_Comm, fi_Magic, fdt_Expiration, fc_Arrow);
                if (li_Ticket == -1)
                {
                    if (fErrorHandling (bi_Err, lb_InvalidSTOP))
                    {
                       return (-1);
                    }
				        fWrite_Log (StringConcatenate ("Error Occured : ", fErrorDescription (bi_Err)), bb_PrintPermission, bb_CommentPermission);
				        fWrite_Log (StringConcatenate ("fOrderSend(): ", fs_Symbol, "/", fGet_NameOP (fi_Type), " | Price = ", DToS (fd_Price)), bb_PrintPermission, bb_CommentPermission);
                    li_Cnt++;
                    if (i_NumberOfTry < li_Cnt)
                       return (-1);
                    RefreshRates();
                    if (fi_Type < 2)
                    {
                       fd_Price = ND (fGet_TradePrice (cmd, true, fs_Symbol));
                    }
                    //----       
                    else
                    {
                       fCheck_ValidOOP (fs_Symbol, fi_Type, fd_Price, fd_SL, fd_TP, fGet_TradePrice (cmd, true, fs_Symbol), lb_FixInvalidPrice, true);
                    }
                    continue;
                }
                else
                {
                   break;
                }
            }
            if (li_Ticket > 0 && (fd_SL != 0.0 || fd_TP != 0.0))
            {
                li_Cnt = 0;
                if (OrderSelect (li_Ticket, SELECT_BY_TICKET))
                {                  
                    if (fi_Type % 2 == 0)
                    {
                       cmd = 1;
                    }
                    else
                    {
                       cmd = -1;
                    }
                    fOrderModify (li_Ticket, OrderOpenPrice(), fd_SL, fd_TP, fdt_Expiration, fc_Arrow);
                }
                else
                {
                   fWrite_Log (StringConcatenate ("OrderSelectError :: ", GetLastError()), bb_PrintPermission, bb_CommentPermission);
                }
            }
            fd_Lot -= bd_MAXLOT;
            if (fd_Lot <= 0.0)
               break;
            ld_Lots = MathMin (bd_MAXLOT, fd_Lot);
        }
    }
    //----   
    fPrint (StringConcatenate ("ls_fName => ", fErrorToString (bi_Err)), bb_PrintPermission, bb_CommentPermission);
//----
    return (li_Ticket);
}
//=========================================================================================================================================
// 1.2     ( TP  SL). =========================================================================
int fOrderModify (int fi_Ticket,               // OrderTicket()
                  double fd_OpenPrice,         // OpenPrice
                  double fd_NewSL,             //  StopLoss ( !!!)
                  double fd_NewTP,             //  TakeProfit ( !!!)
                  datetime fdt_Expiration = 0, //    
                  color fc_Arrow = CLR_NONE)   //    StopLoss / TakeProfit  
{
//----   
    if (fd_NewSL == OrderStopLoss() && fd_NewTP == OrderTakeProfit())
        return (false);
//----
    string ls_fName = "fOrderModify()";
    int    li_cnt = 0;
    double ld_Price;
    bool   lb_result = false,
           lb_InvalidSTOP = false,
           lb_FixInvalidPrice = false;    //    
//----        
    fGet_MarketInfo (OrderSymbol(), fi_Ticket);
//----    FREEZELEVEL  STOPLEVEL
    if (!fCheck_LevelsBLOCK (3, bs_Symbol, bi_Type, fd_OpenPrice, fd_NewSL, fd_NewTP, lb_FixInvalidPrice))
    {
       if (StringLen (bs_ErrorTL) > 0)
       {
          fWrite_Log (bs_ErrorTL, bb_PrintPermission, bb_CommentPermission);
       } 
       return (-1);
    }
    bi_Err = -1;
//----     
    if (fc_Arrow == CLR_NONE)
       fc_Arrow = bca_Modify[OrderType() % 2];
//----    
    if (!bb_RealTrade)
    {
        lb_result = OrderModify (fi_Ticket, fd_OpenPrice, fd_NewSL, fd_NewTP, fdt_Expiration, fc_Arrow);
   
        if (!lb_result)
            fWrite_Log (StringConcatenate ("fOrderModify(): ", fErrorToString (GetLastError())), bb_PrintPermission, bb_CommentPermission);
        return (lb_result);
    }
//----    on-line 
    while (IsTradeAllowed() == true)
    {
        if (!IsExpertEnabled() || IsStopped() || li_cnt > 200)
        {
            fWrite_Log (StringConcatenate ("Error: Trying to modify ticket #", fi_Ticket, ", which is ", fGet_NameOP (bi_Type), " NOT IsTradeContextBusy"), bb_PrintPermission, bb_CommentPermission);
            if (!IsExpertEnabled()) {fWrite_Log ("Permit ExpertEnabled !!!", bb_PrintPermission, bb_CommentPermission);}
            return (-1);
        }
   
        if (OrderModify (fi_Ticket, fd_OpenPrice, fd_NewSL, fd_NewTP, fdt_Expiration, fc_Arrow))
        {
           lb_result = true;
           break;
        }
   
        if (fErrorHandling (bi_Err, lb_InvalidSTOP))
           break;
		  fWrite_Log (StringConcatenate ("Error Occured : ", fErrorToString (bi_Err)), bb_PrintPermission, bb_CommentPermission);
		  fWrite_Log (StringConcatenate ("fOrderModify(): ", bs_Symbol, "# ", fi_Ticket, "/", fGet_NameOP (bi_Type), " | Price = ", DToS (fd_OpenPrice), " | SL = ", DToS (fd_NewSL), " | TP = ", DToS (fd_NewTP)), bb_PrintPermission, bb_CommentPermission);
   
        if (lb_InvalidSTOP)
        {
            RefreshRates();
            ld_Price = fGet_TradePrice (bi_Type % 2, true, bs_Symbol);
            if (bi_Type < 2)
            {
               fCheck_ValidStops (ld_Price, bi_Type, fd_NewSL, fd_NewTP, false);
            }
            else
            {
               fCheck_ValidOOP (bs_Symbol, bi_Type, fd_OpenPrice, fd_NewSL, fd_NewTP, ld_Price, lb_FixInvalidPrice);
            }
        }
        li_cnt++;
   
        if (i_NumberOfTry < li_cnt)
           return (false);
    }
//----   
    fPrint (StringConcatenate ("ls_fName => ", fErrorToString (bi_Err)), bb_PrintPermission, bb_CommentPermission);
//----
    return (lb_result);
}
//=========================================================================================================================================
// 1.3     . =======================================================================================
bool fOrderClose (int fi_Ticket,              // OrderTicket()
                  double fd_Lots,             // OrderLots()
                  double fd_Price,            //  
                  int fi_Slippage,            // 
                  color fc_Arrow = CLR_NONE)  //     
{
    string ls_fName = "fOrderClose";
    //----    
    if (OrderType() > 1) return (false);
    bool lb_result = false, lb_InvalidSTOP = false;
//----
    if (fc_Arrow == CLR_NONE) fc_Arrow = bca_Close[OrderType()];
    //----     
    if (!bb_RealTrade)
    {
        lb_result = OrderClose (fi_Ticket, fd_Lots, fd_Price, fi_Slippage, fc_Arrow);
        if (!lb_result) fWrite_Log (StringConcatenate ("fOrderClose(): ", fErrorToString (GetLastError())), bb_PrintPermission, bb_CommentPermission);
        return (lb_result);
    }
    int li_cnt = 0;
    //----        
    fGet_MarketInfo (OrderSymbol(), fi_Ticket);
    //----    FREEZELEVEL
    if (!fCheck_LevelsBLOCK (1, bs_Symbol, bi_Type, fd_Price, bd_CurSL, bd_CurTP, lb_InvalidSTOP))
    {
        if (StringLen (bs_ErrorTL) > 0)
        {
            fWrite_Log (bs_ErrorTL, bb_PrintPermission, bb_CommentPermission);
        }
        return (false);
    }
    bi_Err = -1;
    //----     on-line 
    while (IsTradeAllowed() == true)
    {
        if (!IsExpertEnabled() || IsStopped() || li_cnt > 200)
        {
            fWrite_Log (StringConcatenate ("Error: Trying to close ticket #", fi_Ticket, ", which is ", fGet_NameOP (bi_Type), " NOT IsTradeContextBusy"), bb_PrintPermission, bb_CommentPermission);
            if (!IsExpertEnabled())
            {
                fWrite_Log ("Permit ExpertEnabled !!!", bb_PrintPermission, bb_CommentPermission);
            }
            return (false);
        }
        if (OrderClose (fi_Ticket, fd_Lots, fd_Price, fi_Slippage, fc_Arrow))
        {
            lb_result = true; break;
        }

        if (fErrorHandling (bi_Err, lb_InvalidSTOP)) break;
		  fWrite_Log (StringConcatenate ("Error Occured : ", fErrorDescription (bi_Err)), bb_PrintPermission, bb_CommentPermission);
		  fWrite_Log (StringConcatenate ("fOrderClose(): ", bs_Symbol, "# ", fi_Ticket, "/", fGet_NameOP (bi_Type), " | Lots = ", DToSByLots (fd_Lots), " | Price = ", DToS (fd_Price), " | SL = ", DToS (bd_CurSL), " | TP = ", DToS (bd_CurTP)), bb_PrintPermission, bb_CommentPermission);
        li_cnt++;
        if (i_NumberOfTry < li_cnt) return (false);
        RefreshRates();
        fd_Price = fGet_TradePrice (bi_Type, true, bs_Symbol);
    }
    //----   
    fPrint (StringConcatenate ("ls_fName => ", fErrorToString (bi_Err)), bb_PrintPermission, bb_CommentPermission);
//----
    return (lb_result);
}
//=========================================================================================================================================
// 1.4      . =============================================================================
bool fOrderCloseBy (int fi_Ticket,              // OrderTicket()
                    int fi_Opposite,            // OrderTicket()  
                    color fc_Arrow = CLR_NONE)  //     
{
    string ls_fName = "fOrderCloseBy()";
    //----    
    if (OrderType() > 1) return (false);
    bool lb_result = false, lb_InvalidSTOP = false;
//----
    if (fc_Arrow == CLR_NONE) fc_Arrow = Yellow;
    //----     
    if (!bb_RealTrade)
    {
        lb_result = OrderCloseBy (fi_Ticket, fi_Opposite, fc_Arrow);
        if (!lb_result) fWrite_Log (StringConcatenate ("fOrderCloseBy(): ", fErrorToString (GetLastError())), bb_PrintPermission, bb_CommentPermission);
        return (lb_result);
    }
    int    li_cnt = 0, lia_Type[] = {-1,-1};
    double lda_Lots[] = {0.0,0.0};
    //----      
    fGet_OrderDetails (fi_Ticket);
    lia_Type[0] = bi_Type;
    lda_Lots[0] = bd_Lots;
    fGet_OrderDetails (fi_Opposite);
    lia_Type[1] = bi_Type;
    lda_Lots[1] = bd_Lots;
    bi_Err = -1;
    //----     on-line 
    while (IsTradeAllowed() == true)
    {
        if (!IsExpertEnabled() || IsStopped() || li_cnt > 200)
        {
            fWrite_Log (StringConcatenate ("Error: Trying to close ticket #", fi_Ticket, ", by ticket #", fi_Opposite, " NOT IsTradeContextBusy", fErrorToString (GetLastError())), bb_PrintPermission, bb_CommentPermission);

            if (!IsExpertEnabled())
            {
                fWrite_Log (StringConcatenate ("Permit ExpertEnabled !!! ", fErrorToString (GetLastError())), bb_PrintPermission, bb_CommentPermission);
            }
            return (false);
        }

        if (OrderCloseBy (fi_Ticket, fi_Opposite, fc_Arrow))
        {
            lb_result = true; break;
        }
        bi_Err = -1;

        if (fErrorHandling (bi_Err, lb_InvalidSTOP)) break;
		fWrite_Log (StringConcatenate ("Error Occurred : ", fErrorToString (GetLastError())), bb_PrintPermission, bb_CommentPermission);

		fWrite_Log (StringConcatenate ("fOrderCloseBy(): ", fErrorToString (GetLastError())), bb_PrintPermission, bb_CommentPermission);
        li_cnt++;

        if (i_NumberOfTry < li_cnt) return (false);
    }
    //----   
    fPrint (StringConcatenate ("ls_fName => ", fErrorToString (bi_Err)), bb_PrintPermission, bb_CommentPermission);
//----
    return (lb_result);
}
//=========================================================================================================================================
// 1.5     . =======================================================================================
bool fOrderDelete (int fi_Ticket,              // OrderTicket()
                   color fc_Arrow = CLR_NONE)  //    
{
    string ls_fName = "fOrderDelete()";
    //----    
    if (OrderType() < 2) return (false);
    bool lb_result = false,
         lb_InvalidSTOP = false;
//----
    if (fc_Arrow == CLR_NONE) fc_Arrow = bca_Close[OrderType() % 2];
    //----     
    if (!bb_RealTrade)
    {
        lb_result = OrderDelete (fi_Ticket, fc_Arrow);
        if (!lb_result) fWrite_Log (StringConcatenate ("fOrderDelete(): ", fErrorToString (bi_Err)), bb_PrintPermission, bb_CommentPermission);
        return (lb_result);
    }
    int    li_cnt = 0;
    double ld_SL, ld_TP, ld_Price;
    //----        
    fGet_MarketInfo (OrderSymbol(), fi_Ticket);
    //----    FREEZELEVEL
    if (!fCheck_LevelsBLOCK (1, bs_Symbol, fi_Ticket, ld_Price, ld_SL, ld_TP, lb_InvalidSTOP)) return (false);
    bi_Err = -1;
    //----     on-line 
    while (IsTradeAllowed() == true)
    {
        if (!IsExpertEnabled() || IsStopped() || li_cnt > 200)
        {
            fWrite_Log (StringConcatenate ("Error: Trying to close ticket #", fi_Ticket, ", which is ", fGet_NameOP (bi_Type), " NOT IsTradeContextBusy"), bb_PrintPermission, bb_CommentPermission);
            if (!IsExpertEnabled())
            {
                fWrite_Log ("Permit ExpertEnabled !!!", bb_PrintPermission, bb_CommentPermission);
            }
            return (false);
        }
        if (OrderDelete (fi_Ticket, fc_Arrow))
        {
            lb_result = true; break;
        }
        if (fErrorHandling (bi_Err, lb_InvalidSTOP)) break;
		  fWrite_Log (StringConcatenate ("Error Occured : ", fErrorDescription (bi_Err)), bb_PrintPermission, bb_CommentPermission);
		  fWrite_Log (StringConcatenate ("fOrderDelete(): ", OrderSymbol(), "# ", fi_Ticket, "/", fGet_NameOP (bi_Type), " | Lots = ", DToSByLots (OrderLots())), bb_PrintPermission, bb_CommentPermission);
        li_cnt++;
        if (i_NumberOfTry < li_cnt) return (false);
    }
    //----   
    fPrint (StringConcatenate ("ls_fName => ", fErrorToString (bi_Err)), bb_PrintPermission, bb_CommentPermission);
//----
    return (lb_result);
}
//=========================================================================================================================================
// 1.6     . =============================================================================================
int fClose_AllOrders (int fi_Type = -1,          //   
                      int fi_TypeProfit = 0)     //   : > 0 - ; < 0 - 
{
    string ls_fName = "fClose_AllOrders()";
    int li_Total = OrdersTotal();
    if (li_Total < 1) return (0);
//----
    int    li_Type, li_ord = 0, li_Ticket;
    double ld_ClosePrice, ld_Profit;
    string ls_Symbol;
//----
    bd_Profit = 0.0;
    bi_Err = -1;

    for (int li_ORD = li_Total - 1; li_ORD >= 0; li_ORD--)
    {
        if (!fCheck_MyOrdersAdvanced (li_ORD, fi_Type, fi_TypeProfit)) continue;

        li_Type = OrderType();         
        li_Ticket = OrderTicket();
        ls_Symbol = OrderSymbol();

        if (li_Type < 2)
        {
            RefreshRates();
            ld_ClosePrice = fGet_TradePrice (li_Type, bb_RealTrade, ls_Symbol);

            if (fOrderClose (li_Ticket, OrderLots(), ld_ClosePrice, i_Slippage))
            {
                li_ord++;

                if (!OrderSelect (li_Ticket, SELECT_BY_TICKET, MODE_HISTORY)) continue;
                bd_Profit += (OrderProfit() + OrderSwap() + OrderCommission());
                continue;
            }
        }
        else
        {
            if (fOrderDelete (li_Ticket)) li_ord++;
        }
     }
    //----   
    fPrint (StringConcatenate ("ls_fName => ", fErrorToString (bi_Err)), bb_PrintPermission, bb_CommentPermission);
//----
    return (li_ord);
}
//=========================================================================================================================================
// 1.7         . =============================================================
int fClose_AllOrdersByRange (int fi_Type = -2,        // OrderType
                             bool fb_IsProfit = true) //     :
                                                      // TRUE -     ;
                                                      // FALSE -     ;
{
    double ld_Price;
	 int    lia_Tickets[], li_cnt = 0,
           li_Size = fMyTickets (lia_Tickets, fi_Type, fb_IsProfit);
//----
	for (int li_IND = 0; li_IND < li_Size; li_IND++)
	{
	    if (!OrderSelect (lia_Tickets[li_IND], SELECT_BY_TICKET)) continue;
       
       ld_Price = fGet_TradePrice (OrderType(), bb_RealTrade, OrderSymbol());
       
       if (fOrderClose (lia_Tickets[li_IND], OrderLots(), ld_Price, i_Slippage)) li_cnt++;
	}
//----
    return (li_cnt);
}
//=========================================================================================================================================
// 1.8       . =========================================================================
int fClose_AllOrdersBy (//double& fd_Pribul,         //    
                        int fi_Type = -2,          //   
                        int fi_Period = 0,         // 
                        int fi_TypeProfit = 0)     //   : > 0 - ; < 0 - 
{
    string ls_fName = "fClose_AllOrdersBy()";
    int li_Total = OrdersTotal();
    if (li_Total < 1) return (0);
//----
    int    li_Type, li_ord = 0, li_Ticket, li_size;
    double ld_ClosePrice, ld_Profit, lda_MyTikets[][2][2], lda_Lots[2];
    string ls_Symbol;
//----
    bd_Profit = 0.0;
    bi_Err = -1;
    //----    
    if (fi_Type == -2)
    {
        int li_MyOrders = li_Total;
        while (li_MyOrders > 0)
        {
            ArrayInitialize (lda_Lots, 0.);
            ArrayResize (lda_MyTikets, li_MyOrders);
            ArrayInitialize (lda_MyTikets, 0.);
            li_MyOrders = 0;
            li_size = 0;
            //----   ""
            for (int li_ORD = li_Total - 1; li_ORD >= 0; li_ORD--)
            {
                if (!fCheck_MyOrdersAdvanced (li_ORD, -2, fi_TypeProfit)) continue;
                ls_Symbol = OrderSymbol();
                //----     
                if (li_MyOrders == 0) bs_Symbol = ls_Symbol; else if (bs_Symbol != ls_Symbol) continue;
                li_Type = OrderType();
                li_Ticket = OrderTicket();
                double ld_Lots = OrderLots();
                int    li_IND = 0;
                //----            ""
                while (lda_MyTikets[li_IND][li_Type][0] >= ld_Lots)
                {
                    if (lda_MyTikets[li_IND][li_Type][0] == 0.) break;
                    li_IND++;
                    if (li_IND >= li_MyOrders) break;
                    else if (lda_MyTikets[li_IND][li_Type][0] < ld_Lots)
                    {
                        //---- 
                        for (int li_int = li_size - 1; li_int > li_IND; li_int--)
                        {
                            for (int li_int1 = 0; li_int1 < 2; li_int1++)
                            {lda_MyTikets[li_int][li_Type][li_int1] = lda_MyTikets[li_int-1][li_Type][li_int1];}
                        }
                        break;
                    }
                }
                lda_MyTikets[li_IND][li_Type][0] = ld_Lots;
                lda_MyTikets[li_IND][li_Type][1] = li_Ticket;
                //----     
                lda_Lots[li_Type] += ld_Lots;
                li_size = MathMax (li_size, li_IND + 1);
                li_MyOrders++;
            }
            //----    
            if (li_MyOrders == 0) break;
            ArrayResize (lda_MyTikets, li_size);
            //----   
            /*for (li_OP = 0; li_OP < 2; li_OP++)
            {
                for (li_ORD = 0; li_ORD < li_size; li_ORD++)
                {
                    if (lda_MyTikets[li_ORD][li_OP][1] > 0)
                    {Print ("Ticket = ", lda_MyTikets[li_ORD][li_OP][1], " | Type = ", fGet_NameOP (li_OP), " | Lots ", DSDig (lda_MyTikets[li_ORD][li_OP][0]));}
                }
            }*/
            //----    (  )
            if (lda_Lots[0] > 0.) if (lda_Lots[1] > 0.)
            {
                int li_OP = 1, li_Opposite;
                if (lda_MyTikets[0][0][0] <= lda_MyTikets[0][1][0]) li_Type = 0; else {li_Type = 1; li_OP = 0;}
                li_Ticket = lda_MyTikets[0][li_Type][1];
                li_IND = li_size - 1;
                //----      
                while (lda_MyTikets[0][li_Type][0] > lda_MyTikets[li_IND][li_OP][0]) {li_IND--;}
                li_Opposite = lda_MyTikets[li_IND][li_OP][1];
                if (fOrderCloseBy (li_Ticket, li_Opposite))
                {
                    if (!bb_VirtualTrade)
                    {
                        if (OrderSelect (li_Ticket, SELECT_BY_TICKET, MODE_HISTORY))
                        {
                            ld_Profit = (OrderProfit() + OrderSwap() + OrderCommission());
                            bd_Profit += ld_Profit;
                            if (ld_Profit == 0.)
                            {
                                if (OrderSelect (li_Opposite, SELECT_BY_TICKET, MODE_HISTORY))
                                {
                                    ld_Profit = (OrderProfit() + OrderSwap() + OrderCommission());
                                    bd_Profit += ld_Profit;
                                }
                            }
                        }
                    }
                    li_ord += 2;
                    //----    ""
                    li_Total = OrdersTotal();
                    li_MyOrders = li_Total;
                    continue;
                }
            }
            li_Type = -1;
            //----    
            if (lda_Lots[0] > 0.) li_Type = 0; else if (lda_Lots[1] > 0.) li_Type = 1;
            if (li_Type == -1) continue;
            //----  ,  
            for (li_IND = 0; li_IND < li_size; li_IND++)
            {
                li_Ticket = lda_MyTikets[li_IND][li_Type][1];
                //----    - 
                if (li_Ticket == 0) break;
                if (!OrderSelect (li_Ticket, SELECT_BY_TICKET)) continue;
                RefreshRates();
                ld_ClosePrice = fGet_TradePrice (li_Type, bb_RealTrade, OrderSymbol());
                if (fOrderClose (li_Ticket, OrderLots(), ld_ClosePrice, i_Slippage))
                {
                    li_ord++;
                    if (!bb_VirtualTrade) if (OrderSelect (li_Ticket, SELECT_BY_TICKET, MODE_HISTORY))
                    {bd_Profit += (OrderProfit() + OrderSwap() + OrderCommission());}
                }
            }
            //----    ""
            li_Total = OrdersTotal();
            //----     - 
            if (li_Total == 0) break;
            li_MyOrders = li_Total;
        }
    }
    else li_ord = fClose_AllOrders (fi_Type, fi_TypeProfit);
    //----   
    fPrint (StringConcatenate ("ls_fName => ", fErrorToString (bi_Err)), bb_PrintPermission, bb_CommentPermission);
//----
    return (li_ord);
}
//+=======================================================================================================================================+
//+                                       .                           +
//+=======================================================================================================================================+
// 2.1   StopLevel TP  SL.( ,    TP  SL) =============================================
bool fCheck_ValidStops (double fd_Price,           //  
                        int fi_Type,               // OrderType()
                        double& fd_SL,             // StopLoss
                        double& fd_TP,             // TakeProfit
                        bool fb_IsNewOrder = true) //  
{
    string ls_fName = "fCheck_ValidStops()",
           lsa_txt[2] = {"",""},
           ls_Symbol = bs_Symbol;
    
    if (!fb_IsNewOrder) ls_Symbol = OrderSymbol(); 
    double ld_OrigSL = fd_SL, ld_OrigTP = fd_TP, ld_NewSL, ld_NewTP;
    bool   lb_result = True;
    bi_Err = -1;
    //----  SL  0
    if (fd_SL != 0.0)
    {
        if (fi_Type % 2 == OP_BUY)
        {
            ld_NewSL = fd_Price - bd_STOPLEVEL;
            lsa_txt[0] = StringConcatenate (ls_fName, ": SL = ", DToS (ld_OrigSL), " | new SL [", DToS (ld_NewSL), "] = price [", DToS (fd_Price), "] - MinSTOP [", DToS (bd_STOPLEVEL), "]");
            
            if (fb_IsNewOrder)
            {
                ld_NewSL -= bd_Spread;
                lsa_txt[1] = StringConcatenate (ls_fName, ": Minus spread [", DToS (bd_Spread), "]");
            }
    
            fd_SL = MathMin (fd_SL, ld_NewSL);
            
            if (!fb_IsNewOrder)
            {
                if (OrderStopLoss() != 0.0)
                {
                   if (ND (OrderStopLoss() - fd_SL) >= 0.0)
                      lb_result = false;
                }
            }
        }
        else
        {
            ld_NewSL = fd_Price + bd_STOPLEVEL;
            lsa_txt[0] = StringConcatenate (ls_fName, ": SL = ", DToS (ld_OrigSL), " | new SL [", DToS (ld_NewSL), "] = price [", DToS (fd_Price), "] + MinSTOP [", DToS (bd_STOPLEVEL), "]");
         
            if (fb_IsNewOrder)
            {
                ld_NewSL += bd_Spread;
                lsa_txt[1] = StringConcatenate (ls_fName, ": Plus spread [", DToS (bd_Spread), "]");
            }
         
            fd_SL = MathMax (fd_SL, ld_NewSL);
         
            if (!fb_IsNewOrder)
            {
                if (OrderStopLoss() != 0.0)
                {
                   if (ND (fd_SL - OrderStopLoss()) >= 0.0)
                      lb_result = false;
                }
            }
        }
    
        fd_SL = ND (fd_SL);
    }
    //----  TP  0
    if (fd_TP != 0.0)
    {
        if (MathAbs (fd_Price - fd_TP) <= bd_STOPLEVEL)
        {
            if (fi_Type % 2 == OP_BUY)
            {
                ld_NewTP = fd_Price + bd_STOPLEVEL;
                fd_TP = MathMax (fd_TP, ld_NewTP);
            }
            else
            {
                ld_NewTP = fd_Price - bd_STOPLEVEL;
                fd_TP = MathMin (fd_TP, ld_NewTP);
            }
    
            fd_TP = ND (fd_TP);
    
            lb_result = true;
        }
    }
    //----    
    if (ND (fd_SL - ld_OrigSL) != 0.0)
    {
        fWrite_Log (StringConcatenate (ls_fName, ": Symbol = ", ls_Symbol, " | MinSTOP = ", DToS (bd_STOPLEVEL), " | spread = ", DToS (bd_Spread)), bb_PrintPermission, bb_CommentPermission); 
        fWrite_Log (lsa_txt[0], bb_PrintPermission, bb_CommentPermission);
        fWrite_Log (lsa_txt[1], bb_PrintPermission, bb_CommentPermission);
        fWrite_Log (StringConcatenate (ls_fName, ": SL   STOPLEVEL (", DToS (bd_STOPLEVEL), "). \n SL : ", DToS (fd_SL)), bb_PrintPermission, bb_CommentPermission);
    }
    
    if (ND (fd_TP - ld_OrigTP) != 0.0)
    {fWrite_Log (StringConcatenate (ls_fName, ": TP   STOPLEVEL (", DToS (bd_STOPLEVEL), "). \n TP : ", DToS (fd_TP)), bb_PrintPermission, bb_CommentPermission);}
    //----  
    if (fd_SL > 0.0) fd_SL = ND (fd_SL);
    if (fd_TP > 0.0) fd_TP = ND (fd_TP);
    //----   
    fPrint (StringConcatenate ("ls_fName => ", fErrorToString (bi_Err)), bb_PrintPermission, bb_CommentPermission);
//----
    return (lb_result);
}
//=========================================================================================================================================
// 2.2       . ==========================================================================
void fCheck_ValidOOP (string fs_Symbol,           // OrderSymbol()
                     int fi_Type,                // OrderType()
                     double& fd_OpenPrice,       // OrderOpenPrice()
                     double& fd_SL,              // StopLoss
                     double& fd_TP,              // TakeProfit
                     double fd_Price,            //    
                     bool& fb_FixInvalidPrice,   //   
                     bool fb_IsNewOrder = false) //  
{
    string ls_Name = "fCheck_ValidOOP()";
    int 	  li_cmd = 1;
    double ld_OrigSL = fd_SL, ld_OrigTP = fd_TP, ld_NewTP, ld_PriceOld;
    bi_Err = -1;
//----
    if (fi_Type == OP_BUYSTOP || fi_Type == OP_BUYLIMIT)
    {
        if (fi_Type == OP_BUYLIMIT) {li_cmd = -1;}
        if (MathAbs (fd_Price - fd_OpenPrice) <= bd_STOPLEVEL)
        {
            if (fb_FixInvalidPrice)
            {
                fd_OpenPrice = fd_OpenPrice + li_cmd * bd_SymPoint;
                if (fd_SL > 0.0) {fd_SL = fd_SL + li_cmd * bd_SymPoint;}
                if (fd_TP > 0.0) {fd_TP = fd_TP + li_cmd * bd_SymPoint;}
                if (fd_SL > 0.0 || fd_TP > 0.0)
                {fWrite_Log (StringConcatenate (ls_Name, ": CHANGE[", fGet_NameOP (fi_Type), "]: SL (now ", DToS (fd_SL), ") | TP (now ", DToS (fd_TP), ")."), bb_PrintPermission, bb_CommentPermission);}
            }
            else
            {
                ld_PriceOld = fd_OpenPrice;
                fd_OpenPrice = fd_Price + li_cmd * bd_STOPLEVEL;
                if (fd_SL > 0.0) {fd_SL += (fd_OpenPrice - ld_PriceOld);}
                if (fd_TP > 0.0) {fd_TP += (fd_OpenPrice - ld_PriceOld);}
                if (fd_SL > 0.0 || fd_TP > 0.0)
                {fWrite_Log (StringConcatenate (ls_Name, ": CHANGE[", fGet_NameOP (fi_Type), "]: new Price = ", DToS (fd_OpenPrice), " | SL (now ", DToS (fd_SL), ") | TP (now ", DToS (fd_TP), ")."), bb_PrintPermission, bb_CommentPermission);}
                fb_FixInvalidPrice = true;
            }
            fCheck_ValidStops (fd_OpenPrice, fi_Type, fd_SL, fd_TP, fb_IsNewOrder);
        }
    }
    else if (fi_Type == OP_SELLSTOP || fi_Type == OP_SELLLIMIT)
    {
        if (fi_Type == OP_SELLSTOP) {li_cmd = -1;}
        if (MathAbs (fd_Price - fd_OpenPrice) <= bd_STOPLEVEL)
        {
            if (fb_FixInvalidPrice)
            {
                fd_OpenPrice = fd_OpenPrice + li_cmd * bd_SymPoint;
                if (fd_SL > 0.0) {fd_SL = fd_SL + li_cmd * bd_SymPoint;}
                if (fd_TP > 0.0) {fd_TP = fd_TP + li_cmd * bd_SymPoint;}
                if (fd_SL > 0.0 || fd_TP > 0.0)
                {fWrite_Log (StringConcatenate (ls_Name, ": CHANGE[", fGet_NameOP (fi_Type), "]: SL (now ", DToS (fd_SL), ") | TP (now ", DToS (fd_TP), ")."), bb_PrintPermission, bb_CommentPermission);}
            }
            else
            {
                if (fi_Type == OP_SELLSTOP) ld_PriceOld = fd_OpenPrice;
                fd_OpenPrice = fd_Price + li_cmd * bd_STOPLEVEL;
                if (fd_SL > 0.0) {fd_SL -= (ld_PriceOld - fd_OpenPrice);}
                if (fd_TP > 0.0) {fd_TP -= (ld_PriceOld - fd_OpenPrice);}
                if (fd_SL > 0.0 || fd_TP > 0.0)
                {fWrite_Log (StringConcatenate (ls_Name, ": CHANGE[", fGet_NameOP (fi_Type), "]: new Price = ", DToS (fd_OpenPrice), " | SL (now ", DToS (fd_SL), ") | TP (now ", DToS (fd_TP), ")."), bb_PrintPermission, bb_CommentPermission);}
                   fb_FixInvalidPrice = true;
            }
            fCheck_ValidStops (fd_OpenPrice, fi_Type, fd_SL, fd_TP, fb_IsNewOrder);
        }
    }
    //----   
    fPrint (StringConcatenate ("ls_fName => ", fErrorToString (bi_Err)), bb_PrintPermission, bb_CommentPermission);
}
//=========================================================================================================================================
// 2.3   STOPLEVEL  FREEZLEVEL. ======================================================================================
bool fCheck_LevelsBLOCK (int fi_Mode,              //   : 1 - Close/Del; 2 - Send; 3 - Modify;
                         string fs_Symbol,         // OrderSymbol()
                         int fi_Type,              // OrderType()
                         double& fd_NewOpenPrice,  // OpenPrice
                         double& fd_NewSL,         // StopLoss
                         double& fd_NewTP,         // TakeProfit
                         bool& fb_FixInvalidPrice) //    
{
    string ls_fName = "fCheckLevelsBLOCK()";
    double ld_Price;
    int    li_cmd, cmd, li_Ticket = 0;
    bool   lb_Freeze = false, lb_MinSTOP = false, lb_NewOrder = false;
//----
    if (fi_Mode == 2) lb_NewOrder = true;
    if (!lb_NewOrder) li_Ticket = OrderTicket();

    //----     ,      ( )
    bd_STOPLEVEL = MarketInfo (fs_Symbol, MODE_STOPLEVEL) * pt;
    bd_FREEZLEVEL = MarketInfo (fs_Symbol, MODE_FREEZELEVEL) * pt;
    bi_Err = -1;  //    .
    
    if (fi_Type == 0) li_cmd = 0;
    else
        if (fi_Type == 1) li_cmd = 1;
        else
            if (fi_Type % 2 == 0) li_cmd = 1;
            else li_cmd = 0;
    
    ld_Price = bda_Price[li_cmd];
    
    //----  
    if (fd_NewSL > 0.0) fd_NewSL = ND (fd_NewSL);
    if (fd_NewTP > 0.0) fd_NewTP = ND (fd_NewTP);
    
    //----     FREEZELEVEL
    if (fi_Mode == 1 || fi_Mode == 3)
    {
        if (fi_Type < 2)
        {
            if (fi_Type == 0) cmd = 1; else cmd = -1;
            lb_Freeze = ((cmd * (ld_Price - bd_CurSL) > bd_FREEZLEVEL || bd_CurSL == 0) && (cmd * (bd_CurTP - ld_Price) > bd_FREEZLEVEL || bd_CurTP == 0));
        }
        else {lb_Freeze = (MathAbs (ld_Price - bd_OpenPrice) > bd_FREEZLEVEL);}
        
        if (!lb_Freeze)
        {
            bs_ErrorTL = StringConcatenate (fGet_NameOP (fi_Type), "[", OrderTicket(), "]:      FreezeLevel !!!");
            return (false);
        }
        //----   -   Close\Delete
        
        if (fi_Mode == 1) {if (bd_CurSL == 0 && bd_CurTP == 0) return (true);}
    }
    //----   -   Send
    else {if (fd_NewSL == 0 && fd_NewTP == 0) return (true);}
    //----     STOPLEVEL
    switch (fi_Mode)
    {
        case 1: //---- Close\Delete orders
            return (true);
        case 2: //---- Send orders
            switch (fi_Type)
            {
                case 0: //---- Send BUY
                    lb_MinSTOP = ((bd_STOPLEVEL <= ld_Price - fd_NewSL || fd_NewSL == 0)
                    && (bd_STOPLEVEL <= fd_NewTP - ld_Price || fd_NewTP == 0));
                    break; 
                case 1: //---- Send SELL
                    lb_MinSTOP = ((bd_STOPLEVEL <= fd_NewSL - ld_Price || fd_NewSL == 0)
                    && (bd_STOPLEVEL <= ld_Price - fd_NewTP || fd_NewTP == 0));
                    break;
                case 2: //---- Send BUYLIMIT
                    if ((bd_STOPLEVEL <= ld_Price - fd_NewOpenPrice)
                    && (bd_STOPLEVEL <= fd_NewOpenPrice - fd_NewSL || fd_NewSL == 0)
                    && (bd_STOPLEVEL <= fd_NewTP - fd_NewOpenPrice || fd_NewTP == 0))
                    lb_MinSTOP = true;
                    break;  
                case 3: //---- Send SELLLIMIT
                    if ((bd_STOPLEVEL <= fd_NewOpenPrice - ld_Price)
                    && (bd_STOPLEVEL <= fd_NewSL - fd_NewOpenPrice || fd_NewSL == 0)
                    && (bd_STOPLEVEL <= fd_NewOpenPrice - fd_NewTP || fd_NewTP == 0))
                    lb_MinSTOP = true;
                    break;
                case 4: //---- Send BUYSTOP
                    if ((bd_STOPLEVEL <= fd_NewOpenPrice - ld_Price)
                    && (bd_STOPLEVEL <= fd_NewOpenPrice - fd_NewSL || fd_NewSL == 0)
                    && (bd_STOPLEVEL <= fd_NewTP - fd_NewOpenPrice || fd_NewTP == 0))
                    lb_MinSTOP = true;
                    break;
                case 5: //---- Send SELLSTOP
                    if ((bd_STOPLEVEL <= ld_Price - fd_NewOpenPrice)
                    && (bd_STOPLEVEL <= fd_NewSL - fd_NewOpenPrice || fd_NewSL == 0)
                    && (bd_STOPLEVEL <= fd_NewOpenPrice - fd_NewTP || fd_NewTP == 0))
                    lb_MinSTOP = true;
                    break;
            }
            break;
        case 3: //---- Modify orders
            switch (fi_Type)
            {
                case 0: //---- Modify BUY
                    lb_MinSTOP = ((bd_STOPLEVEL <= ld_Price - fd_NewSL || fd_NewSL == 0)
                    && (bd_STOPLEVEL <= fd_NewTP - ld_Price || fd_NewTP == 0));
                    if (fd_NewSL >= ld_Price) return (false);
                    break; 
                case 1: //---- Modify SELL
                    lb_MinSTOP = ((bd_STOPLEVEL <= fd_NewSL - ld_Price || fd_NewSL == 0)
                    && (bd_STOPLEVEL <= ld_Price - fd_NewTP || fd_NewTP == 0));
                    if (fd_NewSL <= ld_Price) return (false);
                    break;
                case 2: //---- Modify BUYLIMIT
                    if ((bd_STOPLEVEL <= bd_OpenPrice - bd_CurSL || bd_CurSL == 0)
                    && (bd_STOPLEVEL <= bd_CurTP - bd_OpenPrice || bd_CurTP == 0))
                    {
                        if ((bd_STOPLEVEL <= ld_Price - fd_NewOpenPrice)
                        && (bd_STOPLEVEL <= fd_NewOpenPrice - fd_NewSL || fd_NewSL == 0)
                        && (bd_STOPLEVEL <= fd_NewTP - fd_NewOpenPrice || fd_NewTP == 0))
                        lb_MinSTOP = true;
                    }
                    break;                 
                case 3: //---- Modify SELLLIMIT
                    if ((bd_STOPLEVEL <= bd_CurSL - bd_OpenPrice || bd_CurSL == 0)
                    && (bd_STOPLEVEL <= bd_OpenPrice - bd_CurTP || bd_CurTP == 0)) 
                    {
                        if ((bd_STOPLEVEL <= fd_NewOpenPrice - ld_Price)
                        && (bd_STOPLEVEL <= fd_NewSL - fd_NewOpenPrice || fd_NewSL == 0)
                        && (bd_STOPLEVEL <= fd_NewOpenPrice - fd_NewTP || fd_NewTP == 0))
                        lb_MinSTOP = true;
                    }
                    break;   
                case 4: //---- Modify BUYSTOP
                    if ((bd_STOPLEVEL <= bd_OpenPrice - bd_CurSL || bd_CurSL == 0)
                    && (bd_STOPLEVEL <= bd_CurTP - bd_OpenPrice || bd_CurTP == 0))  
                    {
                        if ((bd_STOPLEVEL <= fd_NewOpenPrice - ld_Price)
                        && (bd_STOPLEVEL <= fd_NewOpenPrice - fd_NewSL || fd_NewSL == 0)
                        && (bd_STOPLEVEL <= fd_NewTP - fd_NewOpenPrice || fd_NewTP == 0))
                        lb_MinSTOP = true;
                    }
                    break; 
                case 5: //---- Modify SELLSTOP
                    if ((bd_STOPLEVEL <= bd_CurSL - bd_OpenPrice || bd_CurSL == 0)
                    && (bd_STOPLEVEL <= bd_OpenPrice - bd_CurTP || bd_CurTP == 0)) 
                    {
                        if ((bd_STOPLEVEL <= ld_Price - fd_NewOpenPrice)
                        && (bd_STOPLEVEL <= fd_NewSL - fd_NewOpenPrice || fd_NewSL == 0)
                        && (bd_STOPLEVEL <= fd_NewOpenPrice - fd_NewTP || fd_NewTP == 0))
                        lb_MinSTOP = true;
                    }
                    break;
            }
    }
    //----     STOPLEVEL
    if (!lb_MinSTOP)
    {
        if (fi_Type < 2)
        {
            //----  Send   
            if (lb_NewOrder)
            {
                if (fi_Type == 0) li_cmd = 1; else if (fi_Type == 1) li_cmd = 0;
                else if (fi_Type % 2 == 0) li_cmd = 0; else li_cmd = 1;
            }
            if (fd_NewSL != 0.0)
            if (li_cmd * (ld_Price - fd_NewSL) < bd_STOPLEVEL)
            if (li_cmd * (ld_Price - fd_NewSL) > 0.0)
            {
                bs_ErrorTL = StringConcatenate ("STOPLEVEL[", bd_STOPLEVEL, "] > for NewSL[", li_cmd * ld_Price - fd_NewSL, "]");
            }
            
            if (fd_NewTP != 0.0)
            if (li_cmd * (fd_NewTP - ld_Price) < bd_STOPLEVEL)
            if (li_cmd * (fd_NewTP - ld_Price) > 0.0)
            {
                bs_ErrorTL = StringConcatenate ("STOPLEVEL[", bd_STOPLEVEL, "] > for NewTP[", li_cmd * (fd_NewTP - ld_Price), "]");
            }
            
            fWrite_Log (StringConcatenate (fGet_NameOP (fi_Type), ": ", bs_ErrorTL), bb_PrintPermission, bb_CommentPermission);
            
            //----     
            if (!fCheck_ValidStops (bda_Price[li_cmd], fi_Type, fd_NewSL, fd_NewTP, lb_NewOrder))
            {
                fWrite_Log ("fCheck_ValidStops():     !!!", bb_PrintPermission, bb_CommentPermission); return (false);
            }
            else return (true);
        }
        else
        {
            //----    ( )     
            fCheck_ValidOOP (fs_Symbol, fi_Type, fd_NewOpenPrice, fd_NewSL, fd_NewTP, ld_Price, fb_FixInvalidPrice, lb_NewOrder);
            return (true);
        }
    }
    //----   
    fPrint (StringConcatenate ("ls_fName => ", fErrorToString (bi_Err)), bb_PrintPermission, bb_CommentPermission);
//----
    return (lb_MinSTOP);
}
//+=======================================================================================================================================+
//+                                                     .                                                     +
//+=======================================================================================================================================+
// 3.1    . ===========================================================================================================
bool fCheck_TypeOrder (int fi_Type,      // -1 - ; -2 - ; 7 - 
                       int fi_CheckType) // OrderType
{
//----
    if (fi_Type >= 0)
    {
        if (fi_Type == 7)
        {
            if (fi_CheckType < 2) return (false);
        }
        else
        {
            if (fi_Type != fi_CheckType) return (false);
        }
    }
    else
    {
        if (fi_Type == -2)
        {
            if (fi_CheckType > 1) return (false);
        }
    }    
//----
    return (true);
}
// 3.2     . ==============================================================================================
bool fCheck_MyMagic (string fs_List,             //  
                     string fs_Delimiter = ",")  //     fs_List
{
    int li_Len = StringLen (fs_List);
//----
    if (li_Len == 0) return (true);
    //----    ""
    if (fs_List == "-1") return (true);
    string ls_Magic = OrderMagicNumber();
    //----       
    int li_N = StringFind (fs_List, ls_Magic);
    //----       
    if (li_N < 0) return (false);
    //----       
    if (fs_List == ls_Magic) return (true);
    //----   
    int li_LenMagic = StringLen (ls_Magic);
    //----        (Delimiter)
    if (StringSubstr (fs_List, li_N + li_LenMagic, 1) == fs_Delimiter) return (true);
    //----      
    if (li_Len == li_N + li_LenMagic) return (true);
    //----   
    fPrint (StringConcatenate ("fCheck_MyMagic => ", fErrorToString (bi_Err)), bb_PrintPermission, bb_CommentPermission);
//----
    return (false);
}
// 3.3  ""    . ================================================================================
bool fCheck_MyOrdersAdvanced (int fi_Pos,                //      OrdersTotal()
                              int fi_Type = -2,          //  
                              int fi_TypeProfit = 0)     //   : > 0 - ; < 0 - 
{
//----
    if (!fCheck_MyOrdersBased (fi_Pos, fi_Type)) return (false);
    //----    
    if (OrderType() < 2) if (fi_TypeProfit != 0)
    {
        double ld_Profit = OrderProfit() + OrderSwap() + OrderCommission();
        if (fi_TypeProfit > 0) if (ld_Profit < 0.0) return (false);
        if (fi_TypeProfit < 0) if (ld_Profit > 0.0) return (false);
    }
//----
    return (true);
}
// 3.4  "" . ============================================================================================================
bool fCheck_MyOrdersBased (int fi_Pos,                //      OrdersTotal()
                           int fi_Type = -2,          //  
                           int fi_Pool = MODE_TRADES) //    
{
//----
    if (!OrderSelect (fi_Pos, SELECT_BY_POS, fi_Pool)) return (false);
    if (StringFind (bs_SymbolList, OrderSymbol()) < 0)
    {
        if (StringLen (bs_SymbolList) > 0) return (false);
    }
    if (!fCheck_MyMagic (bs_MagicList, bs_Delimiter)) return (false);
    if (!fCheck_TypeOrder (fi_Type, OrderType())) return (false);
//----
    return (true);
}
// 3.5      . ============================================================================
int fMyTickets (int& fia_Tickets[],           //     "" 
                int fi_Type = -2,            //  
                bool fb_IsProfit = true)     // TRUE -   
                                             // FALSE -   
{
    int li_total = OrdersTotal(), li_ord = 0, lia_Priority[];
	double lda_Profit[];
//----
    if (li_total == 0) return (0);
    ArrayResize (fia_Tickets, li_total);
    ArrayResize (lda_Profit, li_total);
    //----   
    ArrayInitialize (fia_Tickets, 0);

    for (int li_pos = li_total - 1; li_pos >= 0; li_pos--)
    {
        if (!fCheck_MyOrdersBased (li_pos, fi_Type)) continue;

        fia_Tickets[li_ord] = OrderTicket();
        lda_Profit[li_ord] = OrderProfit() + OrderSwap() + OrderCommission();
        li_ord++;
    }

    ArrayResize (fia_Tickets, li_ord);
    ArrayResize (lda_Profit, li_ord);
    ArrayResize (lia_Priority, li_ord);
    fSort_InDecreasingSequance (lia_Priority, lda_Profit);
	 int lia_tmp[], li_PR;
    ArrayResize (lia_tmp, li_ord);
	 ArrayCopy (lia_tmp, fia_Tickets);

	 if (fb_IsProfit)
	 {
	     for (int li_IND = 0; li_IND < li_ord; li_IND++)
        {
            if (fb_IsProfit) li_PR = lia_Priority[li_IND];
            else li_PR = lia_Priority[li_ord-1-li_IND];
            fia_Tickets[li_IND] = lia_tmp[li_PR];
        }
    }
//----
    return (li_ord);
}